#include <forms.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include "global.h"
#include "test.h"
#include "part.h"
#include "layout.h"
#include "element.h"
#include "diskops.h"
#include "tools.h" 
#include "browser.h"

int AS_Browser_InitMenu()
{
  DIR *currdir=NULL;
  struct dirent *inhalt=NULL;
  char *tmp;
  char tmp2[300];
  

  fl_clear_browser(fd_ElementBrowser->brElementSelector);
  if((currdir=opendir((char *)&LayoutData.LibDirPath))!=NULL)
  {
  
    while((inhalt=readdir(currdir))!=NULL)
    {
      if((tmp=strstr(inhalt->d_name,".el\0"))!=NULL)
      {
        *tmp=0;
        fl_add_browser_line(fd_ElementBrowser->brElementSelector,inhalt->d_name);
      }

    } 
    
    closedir(currdir);
  }
  else
  {
    sprintf((char *)&tmp2,"library path not found:\n %s",(char *)&LayoutData.LibDirPath);
    fl_show_messages((char *)&tmp2);
  }
  
  
  fl_show_form(fd_ElementBrowser->ElementBrowser,FL_PLACE_CENTER,FL_FULLBORDER,"Browser");
  AS_PreviewWin = fl_get_canvas_id(fd_ElementBrowser->cElementPreview);
  fl_add_canvas_handler(fd_ElementBrowser->cElementPreview, Expose, AS_Browser_ExposeEvent, NULL);
  return 0;
}


/******************************************************************************
 *** function   : AS_Browser_ExposeEvent()
 *** description: Diese FUnktion wird bei einem ExposeEvent des Layout-Windows
 ***              aufgerufen.
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int  AS_Browser_ExposeEvent(FL_OBJECT *ob, Window win, int w, int h,
                            XEvent *ev, void *d)
{
  AS_Browser_Repaint();
  return 0;
}


/******************************************************************************
 *** function   : AS_Browser_Repaint()
 *** description: erneuert das Fenster
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Browser_Repaint()
{
  int w,h;
  
  if(AS_PreviewWin==0)
    return -1;
  fl_get_winsize(AS_PreviewWin,&w,&h);
  fl_winset(AS_PreviewWin);
  fl_rectf(0,0,w,h,Colors[BGCOLOR]); 
  if(LayoutData.BrowserElement != NULL)
  {
    LayoutData.BrowserElement->x = w/2;
    LayoutData.BrowserElement->y = h/2;
    AS_Layout_DrawElement(LayoutData.BrowserElement,0,AS_PreviewWin);
  }
  return 0;
}


/******************************************************************************
 *** function   : AS_Browser_LoadElement()
 *** description: erneuert das Fenster
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Browser_LoadElement(char *ElementName)
{
  
  if(AS_PreviewWin == 0)
    return -1;
  if(LayoutData.BrowserElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.BrowserElement);
    LayoutData.BrowserElement=NULL;
  }
  LayoutData.BrowserElement=AS_Element_CreateElement();
  if(AS_Element_LoadContents(ElementName,LayoutData.BrowserElement) != 0)
  {
    AS_Element_DestroyElement(LayoutData.BrowserElement);
    LayoutData.BrowserElement=NULL;
    return -1;
  }
  else
  {
    LayoutData.BrowserElement->ElementType = etELEMENT;
    LayoutData.BrowserElement->next = NULL;
  }
  return 0;
}



/******************************************************************************
 *** function   : AS_Browser_ShowSelectedElement()
 *** description: erneuert das Fenster
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Browser_ShowSelectedElement(int BrowserLine)
{
  char *fname;
  char fname_hlp[256];   /* used to avoid a bug in xform-browser */
  
  fname=(char *)fl_get_browser_line(fd_ElementBrowser->brElementSelector,BrowserLine);
  
  sprintf((char *)&fname_hlp,(char *)fname);
  fl_set_input(fd_ElementBrowser->iSearch,(char *)&fname_hlp);
  AS_Browser_LoadElement((char *)&fname_hlp);
  AS_Browser_Repaint();
}




/* callbacks and freeobj handles for form ElementBrowser */
void cb_brElementSelector(FL_OBJECT *ob, long data)
{
  int CurrentLine;
  
  CurrentLine=fl_get_browser(fd_ElementBrowser->brElementSelector);
  fl_select_browser_line(fd_ElementBrowser->brElementSelector,CurrentLine);
  AS_Browser_ShowSelectedElement(CurrentLine);
}

void cb_iSearch(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_bSearch(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_bSelectorAdd(FL_OBJECT *ob, long data)
{

  int x,y;
  unsigned dummy;
  
  if((LayoutData.BrowserElement == NULL)||(AS_LayoutWin==0))
    return;


  if(LayoutData.ActElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.ActElement);
    LayoutData.ActElement=NULL;
  }

  LayoutData.ActElement=AS_Element_CopyElement(LayoutData.BrowserElement);

  LayoutData.BasicsMode = ELEMENTMODE;
  fl_get_win_mouse(AS_LayoutWin,&x,&y,&dummy);
  LayoutData.ActElement->x = x;
  LayoutData.ActElement->x = y;
  LayoutData.ActElement->ElementType = etELEMENT;
  LayoutData.ActElement->next = NULL;
  AS_Layout_DrawElement(LayoutData.ActElement,Colors[SELECTCOLOR],AS_LayoutWin);
  UnlightButtonsExceptThis(fd_Layout->bAddElement);    /* not unlight addElement */
  SetMouseButtonText("place","flip","rotate");

}

void cb_bSearchNext(FL_OBJECT *ob, long data)
{
  int CurrentLine;
  int MaxLines;
  
  if((MaxLines=fl_get_browser_maxline(fd_ElementBrowser->brElementSelector))==0)
    return;
  
  CurrentLine=fl_get_browser(fd_ElementBrowser->brElementSelector);
  if( (++CurrentLine) > MaxLines)
    CurrentLine=1;
  fl_select_browser_line(fd_ElementBrowser->brElementSelector,CurrentLine);
  fl_set_browser_topline(fd_ElementBrowser->brElementSelector,CurrentLine);
  AS_Browser_ShowSelectedElement(CurrentLine);

}

void cb_bSelectorClose(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_ElementBrowser->ElementBrowser);
  AS_PreviewWin=0;

  if(LayoutData.BrowserElement != NULL)
  {
    AS_Element_DestroyElement(LayoutData.BrowserElement);
    LayoutData.BrowserElement=NULL;
  }
}




