#include <forms.h>
#include <stdlib.h>
#include <stdio.h>
#include "global.h"
#include "test.h"
#include "part.h"
#include "layout.h"
#include "element.h"
#include "diskops.h"
#include "tools.h"



void AS_ConfLayout_InitButtons()
{

  /* we need to set the lightbuttons corresponding to their values */
  fl_set_button(fd_ConfLayout->bShowOrigins,LayoutData.ShowOrigins);
  fl_set_button(fd_ConfLayout->bShowNames,LayoutData.ShowRefNames);
  fl_set_button(fd_ConfLayout->bShowValues,LayoutData.ShowValues);
  fl_set_button(fd_ConfLayout->bFreeText,LayoutData.ShowText);
  fl_set_button(fd_ConfLayout->bFreeText,LayoutData.ShowText);
  fl_set_button(fd_ConfLayout->bMiniDraw,LayoutData.MiniDraw);
  fl_set_button(fd_ConfLayout->bBusWidth,LayoutData.ShowBusWidth);
  fl_set_button(fd_ConfLayout->bDirtyDraw,LayoutData.DirtyDraw);
  fl_set_choice(fd_ConfLayout->cPageSize,LayoutData.PageSize);
  fl_set_choice(fd_ConfLayout->cOrientation,LayoutData.Orientation);
  fl_set_choice(fd_ConfLayout->cFreeTextSize,LayoutData.FreeTextSize);
  fl_set_choice(fd_ConfLayout->cFreeTextStyle,LayoutData.FreeTextStyle);
  fl_set_choice(fd_ConfLayout->cElemTextSize,LayoutData.ElemTextSize);
  fl_set_choice(fd_ConfLayout->cElemTextStyle,LayoutData.ElemTextStyle);
  fl_set_choice(fd_ConfLayout->cBusWidth,LayoutData.BusWidth);

  fl_show_form(fd_ConfLayout->ConfLayout,FL_PLACE_CENTER,FL_FULLBORDER,"Layout-Config");
}




void cb_bShowOrigins(FL_OBJECT *ob, long data)
{
}


void cb_bShowNames(FL_OBJECT *ob, long data)
{
}

void cb_bShowValues(FL_OBJECT *ob, long data)
{
}

void cb_bFreeText(FL_OBJECT *ob, long data)
{
}

void cb_bMiniDraw(FL_OBJECT *ob, long data)
{
}

void cb_bBusWidth(FL_OBJECT *ob, long data)
{
  if(fl_get_button(fd_ConfLayout->bBusWidth))
    fl_show_messages("NOTE: This feature is terribly slow!\nBetter turn it off, until I fixed this behaviour.");
}

void cb_cFreeTextSize(FL_OBJECT *ob, long data)
{
}

void cb_cFreeTextStyle(FL_OBJECT *ob, long data)
{
}

void cb_cBusWidth(FL_OBJECT *ob, long data)
{
}


void cb_bDirtyDraw(FL_OBJECT *ob, long data)
{
}

void cb_cPageSize(FL_OBJECT *ob, long data)
{
}

void cb_cOrientation(FL_OBJECT *ob, long data)
{
}


void cb_bConfLayoutOK(FL_OBJECT *ob, long data)
{

  /* check buttons */
  LayoutData.DirtyDraw   = fl_get_button(fd_ConfLayout->bDirtyDraw);
  LayoutData.ShowOrigins = fl_get_button(fd_ConfLayout->bShowOrigins);
  LayoutData.ShowRefNames= fl_get_button(fd_ConfLayout->bShowNames);
  LayoutData.ShowValues  = fl_get_button(fd_ConfLayout->bShowValues);
  LayoutData.ShowText    = fl_get_button(fd_ConfLayout->bFreeText);
  LayoutData.MiniDraw    = fl_get_button(fd_ConfLayout->bMiniDraw);
  LayoutData.ShowBusWidth= fl_get_button(fd_ConfLayout->bBusWidth);

  /* check choices */
  LayoutData.BusWidth     = fl_get_choice(fd_ConfLayout->cBusWidth);
  LayoutData.ElemTextSize = fl_get_choice(fd_ConfLayout->cElemTextSize);
  LayoutData.ElemTextStyle= fl_get_choice(fd_ConfLayout->cElemTextStyle);
  LayoutData.FreeTextSize = fl_get_choice(fd_ConfLayout->cFreeTextSize);
  LayoutData.FreeTextStyle= fl_get_choice(fd_ConfLayout->cFreeTextStyle);
  LayoutData.PageSize     = fl_get_choice(fd_ConfLayout->cPageSize);
  LayoutData.Orientation  = fl_get_choice(fd_ConfLayout->cOrientation);

  AS_Tools_CalcSizedPageSize();


/*
  if(LayoutData.Orientation==PAGEportrait)
  {
    LayoutData.PageWidth=PageSize[LayoutData.PageSize][0];
    LayoutData.PageHeight=PageSize[LayoutData.PageSize][1];
  }
  else
  {
    LayoutData.PageWidth=PageSize[LayoutData.PageSize][1];
    LayoutData.PageHeight=PageSize[LayoutData.PageSize][0];
  }
*/

  fl_hide_form(fd_ConfLayout->ConfLayout);

  /* only draw, if visible */
  if(AS_LayoutWin!=0)
    AS_LayoutWin_Repaint();

  if(AS_PartWin!=0)
    AS_PartWin_Repaint();


}

void cb_bConfLayoutCancel(FL_OBJECT *ob, long data)
{
  /* all changes discarded */
  fl_hide_form(fd_ConfLayout->ConfLayout);
}

void cb_bConfLayoutHelp(FL_OBJECT *ob, long data)
{
}

void cb_cElemTextSize(FL_OBJECT *ob, long data)
{
}

void cb_cElemTextStyle(FL_OBJECT *ob, long data)
{
}

void cb_bKlickForFun(FL_OBJECT *ob, long data)
{
  fl_show_messages("You clicked something.\nX-Windows does not need to be restarted.\n(like other products do ;-)");
}

void cb_bElectroShocks(FL_OBJECT *ob, long data)
{
  fl_show_messages("bzzzzzzzzzzzzzzz\nThis button has no function.");
}


 
