#ifndef AS_DISKOPS
#define AS_DISKOPS
#endif



#include <stdlib.h>
#include <forms.h>
#include "global.h"
#include "diskops.h"
#include "element.h"
#include "layout.h"
#include "tools.h"


/******************************************************************************
 *** function   : AS_Diskops_SaveAll()
 *** description: Speichert das ganze Layout ab
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Diskops_SaveAll(char *FileName)
{
  FILE *Datei;
  struct sElement *tmp1;
  struct sContent *tmp2;
  
  if( (tmp1=ElementList) == NULL)
    return -1;

  if( (Datei=fopen(FileName,"w")) == NULL)
    return -2;
    
  fprintf(Datei,"VERSION=0.2\n");
  fprintf(Datei,"%d\n",LayoutData.PageSize);
  fprintf(Datei,"%d\n",LayoutData.Orientation);
  fprintf(Datei,"%d\n",(int)LayoutData.PageWidth);
  fprintf(Datei,"%d\n",(int)LayoutData.PageHeight);
  

  while(tmp1 != NULL)
  {
    fprintf(Datei,"{\n");
    fprintf(Datei,"  %d\n",tmp1->ElementType);
    switch(tmp1->ElementType)
    {

      case etTEXT:
      {
        fprintf(Datei,"  %s\n",tmp1->Name);
        fprintf(Datei,"  %d\n",tmp1->RefNum);
        fprintf(Datei,"  %d\n",tmp1->x);
        fprintf(Datei,"  %d\n",tmp1->y);
        fprintf(Datei,"  %d\n",tmp1->Direction);
        fprintf(Datei,"  %d\n",tmp1->Flip);
      } break;


      case etELEMENT:
      {
        AS_Tools_CutLF(tmp1->Name,MAX_NAME);
        fprintf(Datei,"  %s\n",tmp1->Name);
        AS_Tools_CutLF(tmp1->RefName,MAX_REFNAME);
        fprintf(Datei,"  %s\n",tmp1->RefName);
        fprintf(Datei,"  %d\n",tmp1->RefNum);
        AS_Tools_CutLF(tmp1->Value,MAX_VALUE);
        fprintf(Datei,"  %s\n",tmp1->Value);
        fprintf(Datei,"  %d\n",tmp1->NamePosX);
        fprintf(Datei,"  %d\n",tmp1->NamePosY);
        fprintf(Datei,"  %d\n",tmp1->ValuePosX);
        fprintf(Datei,"  %d\n",tmp1->ValuePosY);
        fprintf(Datei,"  %d\n",tmp1->x);
        fprintf(Datei,"  %d\n",tmp1->y);
        fprintf(Datei,"  %d\n",tmp1->Direction);
        fprintf(Datei,"  %d\n",tmp1->Flip);
      } break;
      


      case etJUNCTION:
      {
        fprintf(Datei,"  %d\n",tmp1->x);
        fprintf(Datei,"  %d\n",tmp1->y);
      } break;



      case etBUS:
      case etLINE:
      {
        tmp2=tmp1->Elements;
        while(tmp2 != NULL)
        {
          fprintf(Datei,"  {\n");
          fprintf(Datei,"    %d\n",tmp1->x);
          fprintf(Datei,"    %d\n",tmp1->y);
          fprintf(Datei,"    %d\n",tmp2->x2);
          fprintf(Datei,"    %d\n",tmp2->y2);
          fprintf(Datei,"  }\n");
          tmp2=tmp2->next;
        }
      } break;

    }

    tmp1=tmp1->next;
    fprintf(Datei,"}\n");
  }  
  
  fprintf(Datei,"END\n");
  fclose(Datei);
  return 0;    
}


/******************************************************************************
 *** function   : AS_Diskops_LoadAll()
 *** description: Speichert das ganze Layout ab
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Diskops_LoadAll(char *FileName)
{
  FILE *Datei;
  char Zeile[128],*pZeile;
  struct sElement *tmp1;
  struct sContent *tmp2;
  int i;

  if(ElementList != NULL)
    return -1;

  if( (Datei=fopen(FileName,"r")) == NULL)
    return -2;
    
  pZeile=fgets((char *)&Zeile,125,Datei);     /* Version String */
  pZeile=fgets((char *)&Zeile,125,Datei);     /* PageSize       */
  LayoutData.PageSize=atoi(pZeile);
  pZeile=fgets((char *)&Zeile,125,Datei);     /* Orientation    */
  LayoutData.Orientation=atoi(pZeile);
  pZeile=fgets((char *)&Zeile,125,Datei);     /* FreePageWidth  */
  LayoutData.PageWidth=atoi(pZeile);
  pZeile=fgets((char *)&Zeile,125,Datei);     /* FreePageHeight */
  LayoutData.PageHeight=atoi(pZeile);
    
  AS_Tools_CalcSizedPageSize();


  while(!feof(Datei))
  {
    pZeile=fgets((char *)&Zeile,125,Datei); 

    if( (strcmp(pZeile,"END\n") == 0) || (strcmp(pZeile,"END") == 0) )
      break;

    if(*pZeile == '{')
    {
      pZeile=fgets((char *)&Zeile,125,Datei);
      i=atoi((char *)&Zeile);
      switch(i)
      {


        case etJUNCTION:
        {
          tmp1=AS_Element_CreateElement();
          if(tmp1 != NULL)
          {
            tmp1->ElementType = etJUNCTION;
            pZeile=fgets((char *)&Zeile,125,Datei);
            tmp1->x = atoi((char *)&Zeile);
            pZeile=fgets((char *)&Zeile,125,Datei);
            tmp1->y = atoi((char *)&Zeile);
            pZeile=fgets((char *)&Zeile,125,Datei);
            if(*pZeile != '}')
              AS_Element_DestroyElement(tmp1);
            else
              AS_Element_AddElementToElementList(tmp1);
          } /* end Fehler neues Element */
        } break; /* end case JUNCTION */
        
        
        case etTEXT:
        {
          tmp1=AS_Element_CreateElement();
          if(tmp1 != NULL)
          {
            tmp1->ElementType=etTEXT;
            pZeile=fgets((char *)&Zeile,125,Datei);  /* Text */
            AS_Tools_CutLF((char *)&Zeile,MAX_NAME+2);
            strcpy((char *)&tmp1->Name,(char *)&Zeile[2]);
            pZeile=fgets((char *)&Zeile,125,Datei);  /* RefNum */
            tmp1->RefNum = atoi((char *)&Zeile);
            if(tmp1->RefNum==0)
              tmp1->RefNum=LayoutData.FreeTextSize;
            pZeile=fgets((char *)&Zeile,125,Datei);  /* x */
            tmp1->x = atoi((char *)&Zeile);
            pZeile=fgets((char *)&Zeile,125,Datei);  /* y */
            tmp1->y = atoi((char *)&Zeile);
            pZeile=fgets((char *)&Zeile,125,Datei);  /* Direction */
            tmp1->Direction = atoi((char *)&Zeile);
            pZeile=fgets((char *)&Zeile,125,Datei);  /* Flip */
            tmp1->Flip = atoi((char *)&Zeile);
            pZeile=fgets((char *)&Zeile,125,Datei);  /* Ende */
            if(*pZeile != '}')
              AS_Element_DestroyElement(tmp1);
            else
              AS_Element_AddElementToElementList(tmp1);
          }
        } break; /* end case TEXT */




        case etELEMENT:
        {
          pZeile=fgets((char *)&Zeile,125,Datei);  /* Dateiname */
          pZeile=strstr((char *)&Zeile,".");
          if(pZeile != NULL) /* alles hinter dem Punkt entfernen */
            *pZeile=0;
	  AS_Tools_CutLF((unsigned char *)&Zeile,100);
          pZeile=(char *)&Zeile;
          while( (*pZeile == ' ')&&(*pZeile != 0) )
            pZeile++;

          tmp1=AS_Element_CreateElement();
          if(tmp1 != NULL)
          {
            if(AS_Element_LoadContents(pZeile,tmp1) == 0)
            {
              pZeile=fgets((char *)&Zeile,125,Datei);  /* RefName */
              AS_Tools_CutLF((char *)&Zeile,MAX_REFNAME+2);
              strcpy((char *)&tmp1->RefName,(char *)&Zeile[2]);
              tmp1->ElementType=etELEMENT;
              pZeile=fgets((char *)&Zeile,125,Datei);  /* RefNum */
              tmp1->RefNum = atoi((char *)&Zeile);
              AS_Tools_CutLF((char *)&Zeile,6);

              strcpy((char *)&tmp1->RefDisplay,(char *)&tmp1->RefName);
              if(tmp1->RefNum!=0)
                strncat((char *)&tmp1->RefDisplay,(char *)&Zeile[2],\
                        MAX_REFDISPLAY+2-strlen((char *)&tmp1->RefDisplay));
              else
                /* if the does not enter anything, the reference-name is not shown on screen */
                strcpy((char *)&tmp1->RefDisplay,"");  

              pZeile=fgets((char *)&Zeile,125,Datei);  /* Value */
              AS_Tools_CutLF((char *)&Zeile,MAX_VALUE+2);
              strcpy((char *)&tmp1->Value,(char *)&Zeile[2]);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* NamePosX */
              tmp1->NamePosX = atoi((char *)&Zeile);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* NamePosY */
              tmp1->NamePosY = atoi((char *)&Zeile);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* ValuePosX */
              tmp1->ValuePosX = atoi((char *)&Zeile);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* ValuePosY */
              tmp1->ValuePosY = atoi((char *)&Zeile);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* x */
              tmp1->x = atoi((char *)&Zeile);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* y */
              tmp1->y = atoi((char *)&Zeile);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* Direction */
              tmp1->Direction = atoi((char *)&Zeile);
              for(i=0;i<tmp1->Direction;i++)
                AS_Element_RotateElement(tmp1);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* Flip */
              tmp1->Flip = atoi((char *)&Zeile);
              if(tmp1->Flip == asFLIPPED)
                AS_Element_FlipElement(tmp1);
              pZeile=fgets((char *)&Zeile,125,Datei);  /* Ende */
              if(*pZeile != '}')
                AS_Element_DestroyElement(tmp1);
              else
                AS_Element_AddElementToElementList(tmp1);
            }
            else
              AS_Element_DestroyElement(tmp1);
          }
        } break; /* end case ELEMENT */
        
        
        case etBUS:
        case etLINE:
        {
          pZeile=fgets((char *)&Zeile,125,Datei);  /* Dateiname */
          if( *(pZeile+=2) == '{')
          {
            tmp1=AS_Element_CreateElement();
            if(tmp1 != NULL)
            {
              tmp2=AS_Element_CreateContent();
              if(tmp2 != NULL)
              {
                pZeile=fgets((char *)&Zeile,125,Datei);  /* x1 */
                tmp1->x = atoi((char *)&Zeile);
                pZeile=fgets((char *)&Zeile,125,Datei);  /* y1 */
                tmp1->y = atoi((char *)&Zeile);
                pZeile=fgets((char *)&Zeile,125,Datei);  /* x2 */
                tmp2->x2 = atoi((char *)&Zeile);
                pZeile=fgets((char *)&Zeile,125,Datei);  /* y2 */
                tmp2->y2 = atoi((char *)&Zeile);
                pZeile=fgets((char *)&Zeile,125,Datei);  /* } */
                if( *(pZeile+2) != '}')
                {
                  AS_Element_DestroyElement(tmp1);
                  AS_Element_DestroyContent(tmp2);
                }
                else
                {
                  tmp2->Color = ( i == etLINE) ? Colors[WIRECOLOR]:Colors[BUSCOLOR];
                  tmp2->x1=0;
                  tmp2->y1=0;
                  tmp1->ElementType=(i == etLINE) ? etLINE:etBUS;
                  AS_Element_AddContentToElement(tmp1,tmp2);
                  AS_Element_AddElementToElementList(tmp1);
                }
              }
              else
                AS_Element_DestroyElement(tmp1);
            } /* end if neues Element kreiert */
          } /* end if Anfang Liniendaten */
        } break; /* end case LINE */



      } /* end switch */
    } /* end Anfang Element */
  } /* end while */
  
  
  fclose(Datei);
  return 0;  
}
