#ifndef AS_ELEMENT
#define AS_ELEMENT
#endif

#include <stdlib.h>
#include <forms.h>
#include "global.h"
#include "element.h"
#include "tools.h"


/******************************************************************************
 *** function   : AS_Element_AddElementToElementList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_AddElementToElementList(struct sElement *dieses)
{
  if(dieses == NULL)
    return -1;
    
  dieses->last=NULL;       /* wird noch nicht benutzt! */

  if(ElementList == NULL)
  {
    dieses->next=NULL;
    ElementList=dieses;
  }
  else
  {
    dieses->next=ElementList;
    ElementList=dieses;
  }

  return 0;
}



/******************************************************************************
 *** function   : AS_Element_AddElementToSelectList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_AddElementToSelectList(struct sElement *dieses)
{
  if(dieses == NULL)
    return -1;
    
  dieses->last=NULL;       /* wird noch nicht benutzt! */

  if(SelectList == NULL)
  {
    dieses->next=NULL;
    SelectList=dieses;
  }
  else
  {
    dieses->next=SelectList;
    SelectList=dieses;
  }

  return 0;
}



/******************************************************************************
 *** function   : AS_Element_AddElementToCopyList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_AddElementToCopyList(struct sElement *dieses)
{
  if(dieses == NULL)
    return -1;
    
  dieses->last=NULL;       /* wird noch nicht benutzt! */

  if(CopyList == NULL)
  {
    dieses->next=NULL;
    CopyList=dieses;
  }
  else
  {
    dieses->next=CopyList;
    CopyList=dieses;
  }

  return 0;
}



/******************************************************************************
 *** function   : AS_Element_RemoveElementFromElementList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_RemoveElementFromElementList(struct sElement *dieses)
{
  struct sElement *tmp1,*tmp2;
  
  if((dieses==NULL)||(ElementList==NULL))
    return -1;
  
  tmp1=ElementList;
  tmp2=NULL;
  
  /* check, if element is in list */
  while(tmp1 != dieses)
  {
    if(tmp1==NULL)
      return -1;
    tmp2=tmp1;
    tmp1=tmp1->next;
  }
  
  if(tmp2==NULL)                       /* our element must be the first entry...*/
    ElementList=dieses->next;
  else                                 /* ...or anywhere else                   */
  {
    tmp2->next=dieses->next;           /* could be NULL    */
  }
  
  dieses->next=NULL;                 /* just for fun ;-) */
  AS_Element_DestroyElement(dieses);  /* always returns 0 */
  return 0;                          /* so does this;-)  */

}




/******************************************************************************
 *** function   : AS_Element_RemoveElementFromSelectList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_RemoveElementFromSelectList(struct sElement *dieses)
{
  struct sElement *tmp1,*tmp2;
  
  if((dieses==NULL)||(SelectList==NULL))
    return -1;
  
  tmp1=SelectList;
  tmp2=NULL;
  
  /* check, if element is in list */
  while(tmp1 != dieses)
  {
    if(tmp1==NULL)
      return -1;
    tmp2=tmp1;
    tmp1=tmp1->next;
  }
  
  if(tmp2==NULL)                       /* our element must be the first entry...*/
    SelectList=dieses->next;
  else                                 /* ...or anywhere else                   */
  {
    tmp2->next=dieses->next;           /* could be NULL    */
  }
  
  dieses->next=NULL;                 /* just for fun ;-) */
  AS_Element_DestroyElement(dieses);  /* always returns 0 */
  return 0;                          /* so does this;-)  */

}





/******************************************************************************
 *** function   : AS_Element_CopyElement()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
struct sElement* AS_Element_CopyElement(struct sElement *dieses)
{
  struct sElement *tmp1;
  struct sContent *tmp2,*tmp3;

  tmp1=AS_Element_CreateElement();
  if(tmp1!=NULL)
  {
    strcpy(tmp1->Name,dieses->Name);
    strcpy(tmp1->RefName,dieses->RefName);
    strcpy(tmp1->Value,dieses->Value);
    strcpy(tmp1->RefDisplay,dieses->RefDisplay);
    tmp1->RefNum      = dieses->RefNum;
    tmp1->NamePosX    = dieses->NamePosX;
    tmp1->NamePosY    = dieses->NamePosY;
    tmp1->ValuePosX   = dieses->ValuePosX;
    tmp1->ValuePosY   = dieses->ValuePosY;
    tmp1->ElementType = dieses->ElementType;
    tmp1->x           = dieses->x;
    tmp1->y           = dieses->y;
    tmp1->Direction   = dieses->Direction;
    tmp1->Flip        = dieses->Flip;
    tmp1->Elements    = NULL;
    tmp1->next        = dieses->next;
    tmp1->last        = dieses->last;
    tmp1->crossref    = dieses->crossref;
    
    tmp2=dieses->Elements;
    
    while(tmp2 != NULL)
    {
      tmp3=AS_Element_CreateContent();
      if(tmp3 == NULL)
      {
        AS_Element_DestroyElement(tmp1);
        return NULL;
      }
      tmp3->Type     = tmp2->Type;
      tmp3->Modifier = tmp2->Modifier;
      tmp3->x1       = tmp2->x1;
      tmp3->x2       = tmp2->x2;
      tmp3->y1       = tmp2->y1;
      tmp3->y2       = tmp2->y2;
      tmp3->Color    = tmp2->Color;
      tmp3->next     = NULL;
      if(AS_Element_AddContentToElement(tmp1,tmp3)!=0)
      {
        AS_Element_DestroyElement(tmp1);
        return NULL;
      }
      tmp2=tmp2->next;
    }
  }
  return tmp1;
}


/******************************************************************************
 *** function   : AS_Element_ElementInSelectList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_ElementInSelectList(struct sElement *dieses)
{
  struct sElement *tmp1;
  
  tmp1=SelectList;
  
  while(tmp1!=NULL)
  {
    if(tmp1->crossref==dieses)
      break;
    tmp1=tmp1->next;
  }
  
  if(tmp1==NULL)
    return 0;
  else
    return 1;
}





/******************************************************************************
 *** function   : AS_Element_FlipElement()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_FlipElement(struct sElement *dieses)
{
  struct sContent *tmp1;
  
  if( (dieses==NULL)||(dieses->Elements==NULL) )
    return -1;
    
  tmp1=dieses->Elements;
  
  if( (dieses->Direction==asUP)||(dieses->Direction==asDOWN) )
    while(tmp1!=NULL)
    {
      if(tmp1->Type==asCIRCLE)
        tmp1->x1= -tmp1->x1-tmp1->x2;
      else
      {
        tmp1->x1= -tmp1->x1;
        tmp1->x2= -tmp1->x2;
      }

      tmp1=tmp1->next;
    }
  else
    while(tmp1!=NULL)
    {
      if(tmp1->Type==asCIRCLE)
        tmp1->y1= -tmp1->y1-tmp1->y2;
      else
      {
        tmp1->y1= -tmp1->y1;
        tmp1->y2= -tmp1->y2;
      }

      tmp1=tmp1->next;
    }
  
  
  return 0;
}







/******************************************************************************
 *** function   : AS_Element_RotateElement()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_RotateElement(struct sElement *dieses)
{
  struct sContent *tmp1;
  int a;
  
  if( (dieses==NULL)||(dieses->Elements==NULL) )
    return -1;
    
  tmp1=dieses->Elements;
  
  while(tmp1!=NULL)
  {
    if(tmp1->Type == asLINE)
    {
      a=tmp1->x1;
      tmp1->x1=-tmp1->y1;
      tmp1->y1=a;
      a=tmp1->x2;
      tmp1->x2=-tmp1->y2;
      tmp1->y2=a;
    }
    else
      if(tmp1->Type == asCIRCLE)
      {
        /* ToDo: needs further changes! */
        a=tmp1->x1;
        tmp1->x1=-tmp1->y1-tmp1->y2;
        tmp1->y1=a;
        a=tmp1->x2;
        tmp1->x2=tmp1->y2;
        tmp1->y2=a;
      }
      else
      {
        a=tmp1->x1;
        tmp1->x1=-tmp1->y1-tmp1->y2;
        tmp1->y1=a;
        a=tmp1->x2;
        tmp1->x2=tmp1->y2;
        tmp1->y2=a;
      }
    tmp1=tmp1->next;
  }
  
  return 0;
}



/******************************************************************************
 *** function   : AS_Element_DestroyElementList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
 int AS_Element_DestroyElementList()
 {
   struct sElement *tmp1,*tmp2;
   
   if(ElementList == NULL)
     return 0;
     
   tmp1=ElementList;
   
   while(tmp1 != NULL)
   {
     tmp2=tmp1->next;
     AS_Element_DestroyElement(tmp1);
     tmp1=tmp2;
   }
   
   ElementList=NULL;
   
   return 0;
 }



/******************************************************************************
 *** function   : AS_Element_DestroySelectList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
 int AS_Element_DestroySelectList()
 {
   struct sElement *tmp1,*tmp2;
   
   if(SelectList == NULL)
     return 0;
     
   tmp1=SelectList;
   
   while(tmp1 != NULL)
   {
     tmp2=tmp1->next;
     AS_Element_DestroyElement(tmp1);
     tmp1=tmp2;
   }
   
   SelectList=NULL;
   
   return 0;
 }


/******************************************************************************
 *** function   : AS_Element_DestroyCopyList()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
 int AS_Element_DestroyCopyList()
 {
   struct sElement *tmp1,*tmp2;
   
   if(CopyList == NULL)
     return 0;
     
   tmp1=CopyList;
   
   while(tmp1 != NULL)
   {
     tmp2=tmp1->next;
     AS_Element_DestroyElement(tmp1);
     tmp1=tmp2;
   }
   
   CopyList=NULL;
   
   return 0;
 }


/******************************************************************************
 *** function   : AS_Element_CreateElement()
 *** description: Diese Funktion erzeugt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
struct sElement* AS_Element_CreateElement()
{
  struct sElement *tmp1;
  
  tmp1=(struct sElement*) malloc(sizeof(struct sElement));
  if(tmp1 == NULL)
    return(NULL);
  
  strcpy(tmp1->Name,"");
  strcpy(tmp1->RefName,"");
  strcpy(tmp1->Value,"");
  strcpy(tmp1->RefDisplay,"");
  tmp1->RefNum=0;
  tmp1->NamePosX    = 0;
  tmp1->NamePosY    = 0;
  tmp1->ValuePosX   = 0;
  tmp1->ValuePosY   = 0;
  tmp1->ElementType = etELEMENT;      /* this sucks */
  tmp1->x = 0;
  tmp1->y = 0;
  tmp1->Direction = asUP;
  tmp1->Flip = asNORMAL;
  tmp1->Elements = NULL;
  tmp1->next = NULL;
  tmp1->last = NULL;
  tmp1->crossref=NULL;
  
  return tmp1;
}


/******************************************************************************
 *** function   : AS_Element_CreateContent()
 *** description: Diese Funktion erzeugt ein Content
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
struct sContent* AS_Element_CreateContent()
{
  struct sContent *tmp1;
  
  tmp1=(struct sContent*) malloc(sizeof(struct sContent));
  if(tmp1 == NULL)
    return(NULL);
  
  tmp1->Type = asLINE;
  tmp1->Modifier = asNORMAL;
  tmp1->x1 = 0;
  tmp1->x2 = 0;
  tmp1->y1 = 0;
  tmp1->y2 = 0;
  tmp1->Color = 0;
  tmp1->next = NULL;
  
  return tmp1;
}


/******************************************************************************
 *** function   : AS_Element_DestroyElement()
 *** description: Diese Funktion zerstrt ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
 int AS_Element_DestroyElement(struct sElement *dieses)
 {
   if(dieses->Elements != NULL)
     AS_Element_DestroyAllContentsOfElement(dieses);
          
   free(dieses);
   return 0;
 }


/******************************************************************************
 *** function   : AS_Element_DestroyContent()
 *** description: Diese Funktion zerstrt ein Content
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
 int AS_Element_DestroyContent(struct sContent *dieses)
 {
   free(dieses);
   return 0;
 }
 

/******************************************************************************
 *** function   : AS_Element_DestroyAllContentOfElement()
 *** description: Diese Funktion zerstrt alle Contents eines Elements
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_DestroyAllContentsOfElement(struct sElement *dieses)
{
  struct sContent *tmp1,*tmp2;

  if(dieses->Elements != NULL)
  {
    tmp1=dieses->Elements;

    while(tmp1 != NULL)
    {
      tmp2=tmp1->next;
      AS_Element_DestroyContent(tmp1);
      tmp1=tmp2;
    }
    
    dieses->Elements = NULL;
  }

  return 0;
} 


/******************************************************************************
 *** function   : AS_Element_AddContentToElement()
 *** description: Diese Funktion hngt ein Content in die Liste eines Elements
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_AddContentToElement(struct sElement *hierhin, struct sContent *dieses)
{
  if( (hierhin == NULL) || (dieses == NULL) )
    return -1;
  
  if(hierhin->Elements == NULL)
  {
    /* es ist das erste Element */
    hierhin->Elements=dieses;
    dieses->next=NULL;
  }
  else
  {
    /* das sind schon andere 'drin */
    dieses->next=hierhin->Elements;
    hierhin->Elements=dieses;
  }
  
  return 0;
}



/******************************************************************************
 *** function   : AS_Element_LoadContents()
 *** description: liest die Contents aus einer Datei
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Element_LoadContents(char *FileName, struct sElement *dieses)
{
  FILE *Datei;
  char Zeile[128],*pZeile;
  char Wort[8][128];
  char fname[300];
  int LineCount;
  struct sContent *tmp1;
  int ReturnCode=0;
  
  
  if(dieses == NULL)
    return -1;
    
  sprintf((char *)&fname,"%s%s.el",(char *)&LayoutData.LibDirPath,FileName);

  if( (Datei=fopen((char *)&fname,"r")) == NULL)
  {
    sprintf((char *)&Zeile,"unable to load file:\n\"%s\"",(char *)&fname);
    fl_show_messages((char *)&Zeile);
    return -1;
  }
    
  fgets((char *)&Zeile,5,Datei);
  AS_Tools_CutLF((char *)&Zeile,MAX_REFNAME);
  strcpy((char *)&dieses->RefName,(char *)&Zeile);

  fgets((char *)&Zeile,15,Datei);
  AS_Tools_CutLF((char *)&Zeile,MAX_VALUE);
  strcpy((char *)&dieses->Value,(char *)&Zeile);
  if((int)dieses->Value[0] == '*')
    dieses->Value[0]=0;

  fgets((char *)&Zeile,15,Datei);
  dieses->NamePosX=atoi((char *)&Zeile);
  fgets((char *)&Zeile,15,Datei);
  dieses->NamePosY=atoi((char *)&Zeile);
  fgets((char *)&Zeile,15,Datei);
  dieses->ValuePosX=atoi((char *)&Zeile);
  fgets((char *)&Zeile,15,Datei);
  dieses->ValuePosY=atoi((char *)&Zeile);


  while(!feof(Datei))
  {
    pZeile=fgets((char *)&Zeile,125,Datei);
    if( (*pZeile == '#')||(*pZeile == '{') )
      continue;
    if(*pZeile=='}')
      break;

    if( (tmp1=AS_Element_CreateContent()) == NULL)
    {
      fl_show_messages("Memory Error!");
      ReturnCode=-1;
      break;
    }
    
    

    LineCount=0;

    do
    {
      LineCount++;
      if(LineCount > 7)
      {
        strcpy((char *)&Zeile,"Error in Line ");
        sprintf((char *)&Wort,"%d",LineCount);
        strncat((char *)&Zeile,(char *)&Wort,10);
        strncat((char *)&Zeile," of file:\n\"",30);
        strncat((char *)&Zeile,FileName,40);
        strncat((char *)&Zeile,"\"",5);
        fl_show_messages((char *)&Zeile);
        ReturnCode=-2;
        break;
      }
      sscanf(pZeile,"%s",(char *)&Wort[LineCount]);
      pZeile=strstr(pZeile,(char *)&Wort[LineCount]);
      pZeile+=strlen((char *)&Wort[LineCount]);
      pZeile++;
      
      
      if(ReturnCode != 0)
        break;

    } while( strcmp((char *)&Wort[LineCount],"END") != 0);
    

    if(strcmp((char *)&Wort[1],"LINE")==0)
      tmp1->Type=asLINE;
    else
      if(strcmp((char *)&Wort[1],"CIRC")==0)
        tmp1->Type=asCIRCLE;
      else
        tmp1->Type=asRECT;

    if(strcmp((char *)&Wort[2],"NORMAL")==0)
      tmp1->Modifier=asNORMAL;
    else
      tmp1->Modifier=asFILLED;
      
    tmp1->x1=atoi((char *)&Wort[3]);
    tmp1->y1=atoi((char *)&Wort[4]);
    tmp1->x2=atoi((char *)&Wort[5]);
    tmp1->y2=atoi((char *)&Wort[6]);

    /* ToDo */
    tmp1->Color=Colors[ELEMENTCOLOR];
    
    AS_Element_AddContentToElement(dieses,tmp1);
    
    
  }
  
  strcpy((char *)&dieses->Name,FileName);

  fclose(Datei);
  
  return ReturnCode;
      
}

