#define DEBUG



  Window AS_LayoutWin;
  Window AS_PartWin;
  Window AS_PreviewWin;
  Window AS_ColorWin;


  extern const int TextStyle[5];
  extern const int TextSize[7];

#define PAGEportrait  1
#define PAGElandscape 2

#define MAXPAGESIZES 4
#define PAGEfree     0
#define PAGEa4       1
#define PAGEa3       2
#define PAGEa2       3
#define PAGEa1       4
#define PAGEa0       5
  extern const int PageSize[MAXPAGESIZES][2];
  

  struct sContent
  {
    int Type;                  /* LINE, CIRCLE, RECT */
    int Modifier;              /* MOD_NORMAL, MOD_FILLED */
    int x1,y1,x2,y2;           /* Koordinaten */
    long Color;                /* na, was wohl ?? */
    struct sContent *next;     /* das nchste Teilchen... */
  };

#define MAX_REFNAME     5
#define MAX_NAME      150
#define MAX_REFDISPLAY 10
#define MAX_VALUE      20




  struct sElement
  {
    int ElementType;
    char Name[MAX_NAME];             /* Name des Elements oder Text (z.B. "pnp", oder "74hc08") */
    char RefName[MAX_REFNAME];       /* Referenz Bezeichnung (z.B. "D","R","C" etc... */
    int  RefNum;                     /* Referenz Nummer */
    char RefDisplay[MAX_REFDISPLAY]; /* used for faster drawing */
    char Value[MAX_VALUE];           /* Gre und Einheit (z.B.: "10k", "100" */
    int  NamePosX,NamePosY;          /* Position des Namens */
    int  ValuePosX,ValuePosY;        /* Position des Wertes */
    unsigned x,y;                    /* Position des Bauteiles */
    int Direction;                   /* UP,LEFT,DOWN,RIGHT */
    int Flip;                        /* NORMAL, FLIPPED */
    struct sContent *Elements;       /* die eigentlichen Zeichen-Elemente */
    struct sElement *next,*last;     /* die restlichen Elemente */
    struct sElement *crossref;
  };


  struct
  {
    int GridOn;
    int StayOnGrid;
    int GridSize;
    int SnapSize;
    int DirtyDraw;
    int ShowOrigins;
    int ShowRefNames;
    int ShowValues;
    int ShowText;
    int MiniDraw;
    int ShowBusWidth;
    int BusWidth;
    int ElemTextSize, ElemTextStyle;
    int FreeTextSize, FreeTextStyle;
    int PartWinWidth,PartWinHeight;
    int CanvasWidth,CanvasHeight;
    int CanvasOffsetX,CanvasOffsetY;
    long PageWidth,PageHeight;
    int PageSize;
    int Orientation;
    int AreaX,AreaY,AreaWidth,AreaHeight;
    int BasicsMode;
    int FirstPoint;
    char FileName[300];
    char HomeDirPath[300];
    char LibDirPath[300];
    struct sElement *ActElement;
    struct sElement *BrowserElement;
    struct sElement *LastFound;
  }LayoutData;


  struct
  {
    int TextSize[7];
    char TextStyle[5][20];
    int ScaleX, ScaleY;
    int LineWidth;
    int BusWidth;
    int PageSize;
    int PageLayout;
    int PageBorder;
    int FreeWidth, FreeHeight;
    char Font[30];
    char SpoolCmd[30];
    char Printer[30];
    char Viewer[50];
  }PostscriptData;




#define MAXCOLOR      13
#define ACTCOLOR       0
#define BGCOLOR        1
#define GRIDCOLOR      2
#define WIRECOLOR      3
#define BUSCOLOR       4
#define JUNCTIONCOLOR  5
#define TEXTCOLOR      6
#define ORIGINCOLOR    7
#define ELEMENTCOLOR   8
#define NAMECOLOR      9
#define VALUECOLOR    10
#define SELECTCOLOR   11
#define BORDERCOLOR   12


  int Colors[MAXCOLOR];


  /**************/
  /**** VARS ****/
  /**************/
  
  struct sElement *ElementList;
  struct sElement *SelectList; 
  struct sElement *CopyList; 
   
  
  
