#ifndef AS_LAYOUT
#define AS_LAYOUT
#endif




#include <stdio.h>
#include <forms.h>
#include <math.h>
#include <time.h>
#include "test.h"
#include "global.h"
#include "element.h"
#include "layout.h"
#include "tools.h"



/******************************************************************************
 *** function   : AS_LayoutWin_ExposeEvent()
 *** description: Diese FUnktion wird bei einem ExposeEvent des Layout-Windows
 ***              aufgerufen.
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int  AS_LayoutWin_ExposeEvent(FL_OBJECT *ob, Window win, int w, int h,
                              XEvent *ev, void *d)
{
  fl_winset(AS_LayoutWin);
  /* ToDo */
  /* im Moment kann die Canvas-Gre nicht verndert werden ... */
  LayoutData.CanvasWidth = w;
  LayoutData.CanvasHeight = h;
  AS_LayoutWin_Repaint();
  return 0;
}


/******************************************************************************
 *** function   : AS_LayoutWin_ButtonEvent()
 *** description: Diese FUnktion wird bei einem ButtonEvent des Layout-Windows
 ***              aufgerufen.
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int  AS_LayoutWin_ButtonEvent(FL_OBJECT *ob, Window win, int w, int h,
                              XEvent *ev, void *d)
{
  struct sElement *tmp1,*tmp2;
  int x,y,xg,yg;
  int Found;
  static int AllowEditButton=0;
  
  AS_LayoutWin_GetNextGridPoint(ev->xbutton.x, ev->xbutton.y, &x, &y);
  
  if(LayoutData.BasicsMode==NOMODE)
    return 0;



  switch(LayoutData.BasicsMode)
  {


    case SELECTMODE:
    {

      /* if button 3 was pressed, we remove the last selected element from the list */
      switch(ev->xbutton.button)
      {


        case 3:
        {
          if(SelectList!=NULL)
          {
            AS_Element_RemoveElementFromSelectList(SelectList);
            AS_LayoutWin_Repaint();
          }
        } break; /* end mousebutton 1 */


        case 2:
        {
          if(AllowEditButton)
          {
            cb_bSelEdit(NULL,0);
          }
        } break;


        case 1:
        {
          if(ElementList == NULL)
            break;
        
          AS_LayoutWin_Repaint();

          /* start at the last found element, or at start of list */
          if(LayoutData.LastFound == NULL)
            LayoutData.LastFound = ElementList;

          tmp2 = tmp1 = (LayoutData.LastFound->next == NULL) ? ElementList:LayoutData.LastFound->next;
          Found = 0;

          do
          {
            if(AS_LayoutWin_CheckElementInRange(tmp1,x+LayoutData.CanvasOffsetX,\
                                                   y+LayoutData.CanvasOffsetY)==1)
            {
              LayoutData.LastFound = tmp1;
              Found = 1;

              break;
            }
            tmp1=tmp1->next;
            if(tmp1 == NULL) tmp1 = ElementList;
          } while (tmp1 != tmp2);

          if(Found)
          {
            if(!AS_Element_ElementInSelectList(tmp1))
            {
              tmp2=AS_Element_CopyElement(tmp1);
              if(tmp2!=NULL)
              {
                /* create a link to the original object; (stored in 'last') */
                tmp2->crossref=tmp1;
                /* x and y in SelectList are used for AreaMove */
                AS_Element_AddElementToSelectList(tmp2);
                
                if( (AS_Tools_CountSelectListEntries()==1)&&
                    (SelectList->crossref->ElementType==etELEMENT)&&
                    ( (LayoutData.BasicsMode==SELECTMODE)||
                      (LayoutData.BasicsMode==AREAMODE) ) )
                {
                  SetMouseButtonText("select","edit","one back");
                  AllowEditButton=1;
                }
                else
                  SetMouseButtonText("select","nothing","one back");
                
              }
              AS_LayoutWin_CalcElementArea(SelectList);
              AS_LayoutWin_Repaint();
            }
          }
          else
            LayoutData.LastFound = NULL;
        } break; /* end mousebutton 1 */

      } /* end switch mousebutton */

      if( (AS_Tools_CountSelectListEntries()==1)&&
          (SelectList->crossref->ElementType==etELEMENT)&&
          ( (LayoutData.BasicsMode==SELECTMODE)||
            (LayoutData.BasicsMode==AREAMODE) ) )
      {
        SetMouseButtonText("select","edit","one back");
        AllowEditButton=1;
      }
      else
      {
        SetMouseButtonText("select","nothing","one back");
        AllowEditButton=0;
      }


    } break; /* end selectmode */
    


    case JUNCTIONMODE:
    {
      switch(ev->xbutton.button)
      {
        case 1:
        {
          LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
          LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
          strcpy((char *)&LayoutData.ActElement->Name,"junction");
          tmp1=AS_Element_CopyElement(LayoutData.ActElement);
          if(tmp1 != NULL)
            AS_Element_AddElementToElementList(tmp1);
          AS_LayoutWin_Repaint();
        } break;
      } /* END switch mouse-button */
    } break;


    case LINEMODE:
    case BUSMODE:
    {
      switch(ev->xbutton.button)
      {
        case 1:
        {

          if(LayoutData.FirstPoint==1)
          {
            LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
            LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
            LayoutData.ActElement->Elements->Color=Colors[SELECTCOLOR];
            LayoutData.FirstPoint = 2;
          }
          else
          {
            LayoutData.ActElement->Elements->x2 =
              x+LayoutData.CanvasOffsetX-LayoutData.ActElement->x;
            LayoutData.ActElement->Elements->y2 =
              y+LayoutData.CanvasOffsetY-LayoutData.ActElement->y;
            LayoutData.ActElement->Elements->Color=\
              (LayoutData.BasicsMode == LINEMODE) ? Colors[WIRECOLOR]:Colors[BUSCOLOR];

/* REMOVED FOR MULTI_LINE DRAWING             */
/*            LayoutData.FirstPoint = 1;      */

            strcpy((char *)&LayoutData.ActElement->Name,"line");
            tmp1=AS_Element_CopyElement(LayoutData.ActElement);

/* ADDED FOR MULTI_LINE DRAWING               */
            LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
            LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
            LayoutData.ActElement->Elements->Color=Colors[SELECTCOLOR];

            if(tmp1 != NULL)
            {
              tmp1->Elements->x1=0;
              tmp1->Elements->y1=0;
              tmp1->Elements->Type =asLINE;
        
              if(tmp1->Elements != NULL)
              {
                AS_Element_AddElementToElementList(tmp1);
                AS_LayoutWin_Repaint();
              }
            }
          }
        } break;
        case 3:
        {
          LayoutData.FirstPoint = 1;
          AS_LayoutWin_Repaint();
        } break;
      } /* end switch mouse button */
    } break;  /* end case LINEMODE, BUSMODE */
    

    case ELEMENTMODE:
    {

      switch(ev->xbutton.button)
      {
        
        
        case 3:  /* ROTATE ELEMENT */
        {
          AS_Element_RotateElement(LayoutData.ActElement);
          LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
          LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
          LayoutData.ActElement->Direction++;
          if(LayoutData.ActElement->Direction > 3)
            LayoutData.ActElement->Direction = 0;
          AS_LayoutWin_Repaint();
          AS_Layout_DrawElement(LayoutData.ActElement,Colors[SELECTCOLOR],AS_LayoutWin);  
        } break;
        
        
        case 2:  /* FLIP ELEMENT */
        {
          AS_Element_FlipElement(LayoutData.ActElement);
          LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
          LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
          LayoutData.ActElement->Flip = 
            (LayoutData.ActElement->Flip == asNORMAL) ? asFLIPPED:asNORMAL;
          AS_LayoutWin_Repaint();
          AS_Layout_DrawElement(LayoutData.ActElement,Colors[SELECTCOLOR],AS_LayoutWin);
        } break;
        
        
        case 1:  /* ADD ELEMENT */
        {
          tmp1=AS_Element_CopyElement(LayoutData.ActElement);

          if(tmp1 != NULL)
          {
            tmp1->x = x+LayoutData.CanvasOffsetX;
            tmp1->y = y+LayoutData.CanvasOffsetY;
        
            if(tmp1->Elements != NULL)
            {
              AS_Element_AddElementToElementList(tmp1);
              AS_LayoutWin_Repaint();
            }
          }
        } break;
      } /* end switch mouse button */


    } break;  /* end case ELEMENTMODE */
    
    
    case MOVEMODE:
    {
      if(SelectList != NULL)
      {
        tmp1=SelectList;
        AS_LayoutWin_GetNextGridPoint(LayoutData.CanvasOffsetX-\
                                      LayoutData.AreaX-(LayoutData.AreaWidth/2),
                                      LayoutData.CanvasOffsetY-\
                                      LayoutData.AreaY-(LayoutData.AreaHeight/2),
                                      &xg,&yg);
        while(tmp1!=NULL)
        {
          tmp1->crossref->x = tmp1->x+x+xg;
          tmp1->crossref->y = tmp1->y+y+yg;
          tmp1=tmp1->next;
        }
        AS_LayoutWin_Repaint();
      }
      LayoutData.LastFound=NULL;
      LayoutData.BasicsMode=NOMODE;
      UnlightButtonsExceptThis(NULL);
      SetMouseButtonText("nothing","nothing","nothing");
    } break; /* end case MOVEMODE */
    
    
    case TEXTMODE:
    {
      if(LayoutData.ActElement!=NULL)
      {
        if(ev->xbutton.button==1)
        {
          LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
          LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
          tmp1=AS_Element_CopyElement(LayoutData.ActElement);
          if(tmp1 != NULL)
            AS_Element_AddElementToElementList(tmp1);
          AS_LayoutWin_Repaint();
        }
        else
        {
          LayoutData.BasicsMode=NOMODE;
          UnlightButtonsExceptThis(NULL);
          SetMouseButtonText("nothing","nothing","nothing");
        }
      }
    } break; /* end case TEXTMODE */


    case EDITORMODE:
    {
    } break; /* end EDITORMODE */


    case AREAMODE:
    {
      switch(ev->xbutton.button)
      {
        case 1:
        {
          if(LayoutData.FirstPoint==1)
          {
            LayoutData.AreaX=x+LayoutData.CanvasOffsetX;
            LayoutData.AreaY=y+LayoutData.CanvasOffsetY;
            LayoutData.FirstPoint=2;
          }
          else
          {
            LayoutData.AreaWidth=x+LayoutData.CanvasOffsetX-LayoutData.AreaX;
            LayoutData.AreaHeight=y+LayoutData.CanvasOffsetY-LayoutData.AreaY;
            LayoutData.FirstPoint=1;
            AS_LayoutWin_CopyAreaElementsToSelectList();
            AS_LayoutWin_Repaint();
          }
        } break;
        case 3:
        {
          LayoutData.FirstPoint=1;  
          AS_LayoutWin_Repaint();
        } break;
      }       /* end switch mouse button */
    } break;  /* end case AREAMODE */


    case EDITORMODEVALUEPOS:
    {
      if(SelectList!=NULL)
      {
        SelectList->crossref->ValuePosX=x+LayoutData.CanvasOffsetX-SelectList->crossref->x;
        SelectList->crossref->ValuePosY=y+LayoutData.CanvasOffsetY-SelectList->crossref->y;
        AS_LayoutWin_Repaint();
        LayoutData.BasicsMode=EDITORMODE;
        fl_raise_form(fd_Edit->Edit);
        fl_activate_form(fd_Edit->Edit);
      }
    } break; /* end EDITORMODEVALUEPOS */


    case EDITORMODEREFNAMEPOS:
    {
      if(SelectList!=NULL)
      {
        SelectList->crossref->NamePosX=x+LayoutData.CanvasOffsetX-SelectList->crossref->x;
        SelectList->crossref->NamePosY=y+LayoutData.CanvasOffsetY-SelectList->crossref->y;
        AS_LayoutWin_Repaint();
        LayoutData.BasicsMode=EDITORMODE;
        fl_raise_form(fd_Edit->Edit);
        fl_activate_form(fd_Edit->Edit);
      }
    } break; /* end EDITORMODEREFNAMEPOS */



  } /* end switch */


  return 0;
}


/******************************************************************************
 *** function   : AS_LayoutWin_CalcElementArea()
 *** description: Gibt einen Zeiger auf das angeklickte Element zurck 
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_LayoutWin_CalcElementArea(struct sElement *list)
{
  int MinX=32000,MaxX=0,MinY=32000,MaxY=0;
  struct sElement *tmp1;

  if(list==NULL)
  {
    LayoutData.AreaX=0;
    LayoutData.AreaY=0;
    LayoutData.AreaWidth=0;
    LayoutData.AreaHeight=0;
    return 0;
  }
  
  tmp1=list;
  
  while(tmp1!=NULL)
  {
    if(tmp1->x > MaxX) MaxX=tmp1->x;
    if(tmp1->x < MinX) MinX=tmp1->x;
    if(tmp1->y > MaxY) MaxY=tmp1->y;
    if(tmp1->y < MinY) MinY=tmp1->y;
    tmp1=tmp1->next;
  }
  
  LayoutData.AreaX=MinX;
  LayoutData.AreaY=MinY;
  LayoutData.AreaWidth= MaxX-MinX;
  LayoutData.AreaHeight=MaxY-MinY;
  
  return 0;

}



/******************************************************************************
 *** function   : AS_LayoutWin_CopyAreaElementsToSelectList()
 *** description: Gibt einen Zeiger auf das angeklickte Element zurck 
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_LayoutWin_CopyAreaElementsToSelectList()
{
  struct sElement *tmp1,*tmp2;
  
  if((ElementList==NULL)||(LayoutData.AreaWidth==0)||(LayoutData.AreaHeight==0))
    return 0;

  tmp1=ElementList;
  
  while(tmp1!=NULL)
  {
    if( (tmp1->x > LayoutData.AreaX)&&
        (tmp1->x < LayoutData.AreaX+LayoutData.AreaWidth)&&
        (tmp1->y > LayoutData.AreaY)&&
        (tmp1->y < LayoutData.AreaY+LayoutData.AreaHeight) )
    {
      /* element is inside selected area */
      tmp2=AS_Element_CopyElement(tmp1);
      if(tmp2!=NULL)
      {
        tmp2->crossref=tmp1;
        AS_Element_AddElementToSelectList(tmp2);
      }
    }
    tmp1=tmp1->next;
  }
  
  return 0;
}




/******************************************************************************
 *** function   : AS_LayoutWin_CalcPointLineDistance()
 *** description: Gibt einen Zeiger auf das angeklickte Element zurck 
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
long AS_LayoutWin_CalcPointLineDistance(int x1, int y1, int x2, int y2, int x, int y)
{

/*           _     __   __
           | a X ( rx - r1 ) |
    dis = ----------------------
                   _
                 | a |
*/

 
  long Zaehler, Nenner, Kekse;
  

  Zaehler = labs( (long)((long)(x2-x1)*(long)(y-y1))
                 -(long)((long)(y2-y1)*(long)(x-x1)) );
  Kekse =  (long)((long)(x2-x1)*(long)(x2-x1))
          +(long)((long)(y2-y1)*(long)(y2-y1));
  Nenner = sqrtl(Kekse);

  if(Nenner==0) return -1;
    
  return (long)(Zaehler/Nenner);
  
}


/******************************************************************************
 *** function   : AS_LayoutWin_CalcLength()
 *** description: Gibt einen Zeiger auf das angeklickte Element zurck 
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
long AS_LayoutWin_CalcLength(int x1, int y1, int x2, int y2)
{
  long Laenge;

  Laenge=  (long)(  (long)(x2 - x1)*(long)(x2 - x1)  )
          +(long)(  (long)(y2 - y1)*(long)(y2 - y1)  );

  Laenge=sqrtl(Laenge);
  
  return Laenge;
                      
}


/******************************************************************************
 *** function   : AS_LayoutWin_CheckElementInRange()
 *** description: Gibt einen Zeiger auf das angeklickte Element zurck 
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_LayoutWin_CheckElementInRange(struct sElement *tmp1, int x, int y)
{
  long k,k1,k2;
  struct sContent *tmp2;

  if(tmp1== NULL)
    return 0;
     
  switch(tmp1->ElementType)
  {

    case etTEXT:
    case etJUNCTION:
    {
      if(   ( abs(tmp1->x - x) < LayoutData.SnapSize )
         && ( abs(tmp1->y - y) < LayoutData.SnapSize ) )
        return 1;
      else
        return 0;
    }
        
    case etBUS:
    case etLINE:
    {
      if(tmp1->Elements == NULL) return -1;
      if( (k = AS_LayoutWin_CalcPointLineDistance
                 (tmp1->x, tmp1->y,
                  tmp1->x + tmp1->Elements->x2,
                  tmp1->y + tmp1->Elements->y2,
                  x,y)) < 0)
        return 0;
        
      
      if(k < LayoutData.SnapSize)
      {

        k =AS_LayoutWin_CalcLength(tmp1->x, tmp1->y,
                                   tmp1->x + tmp1->Elements->x2,
                                   tmp1->y + tmp1->Elements->y2);

        k1=AS_LayoutWin_CalcLength(tmp1->x, tmp1->y, x,y );
        if( k1 < LayoutData.SnapSize + k)
        {
          k2=AS_LayoutWin_CalcLength(x,y,tmp1->x+tmp1->Elements->x2,\
                                         tmp1->y+tmp1->Elements->y2);
          if( k2 < LayoutData.SnapSize + k)
            return 1;
        }
        return 0;
      }
      else
        return 0;
    }
      
    case etELEMENT:
    {
      tmp2=tmp1->Elements;
      
      while(tmp2 != NULL)
      {
        if(tmp2->Type == asLINE)
        {
          k = AS_LayoutWin_CalcPointLineDistance (tmp1->x + tmp2->x1,
                                                  tmp1->y + tmp2->y1,
                                                  tmp1->x + tmp2->x2,
                                                  tmp1->y + tmp2->y2,
                                                  x,y);
      

          if(k < LayoutData.SnapSize)
          {
            k =AS_LayoutWin_CalcLength(tmp1->x + tmp2->x1,
                                       tmp1->y + tmp2->y1,
                                       tmp1->x + tmp2->x2,
                                       tmp1->y + tmp2->y2);

            k1=AS_LayoutWin_CalcLength(tmp1->x + tmp2->x1,
                                       tmp1->y + tmp2->y1,x,y );
            if( k1 < LayoutData.SnapSize + k)
            {
              k2=AS_LayoutWin_CalcLength(x,y,
                                         tmp1->x + tmp2->x2,
                                         tmp1->y + tmp2->y2);
              if(k2 < LayoutData.SnapSize + k)
                return 1;
            }
          } /* ENDE if kleiner snapsize */
        } /* ENDE LINIE */
        else
          if(tmp2->Type == asRECT)
          {
                
            /* beim Rechteck wird nur berprft, ob der angeklickte Punkt
               im Rechteck liegt. Der Abstand LayoutData.SnapSize spielt hier
               keine Rolle */
            /* Was ich mir allerdings bei der Scheie mit
               switch(tmp1->Direction)
               gedacht habe, ist mir unverstndlich ;-)  */
            
            
            if( (tmp1->x+tmp2->x1-LayoutData.CanvasOffsetX          < x)&&
                (tmp1->x+tmp2->x1+tmp2->x2-LayoutData.CanvasOffsetX > x)&&
                (tmp1->y+tmp2->y1-LayoutData.CanvasOffsetY          < y)&&
                (tmp1->y+tmp2->y1+tmp2->y2-LayoutData.CanvasOffsetY > y) )
              return 1;

/*
            switch(tmp1->Direction)
            {
              case asUP:
              {
                if((tmp1->x+tmp2->x1 < x)&&(tmp1->x+tmp2->x2 > x)&&
                   (tmp1->y+tmp2->y1 < y)&&(tmp1->x+tmp2->y2 > y))
                  return 1;
              } break;

              case asRIGHT:
              {
                if((tmp1->x-tmp2->y2 < x)&&(tmp1->x-tmp2->y1 > x)&&
                   (tmp1->y+tmp2->x1 < y)&&(tmp1->x+tmp2->x2 > y))
                  return 1;
              } break;
              
              case asDOWN:
              {
                if((tmp1->x-tmp2->x2 < x)&&(tmp1->x-tmp2->x1 > x)&&
                   (tmp1->y-tmp2->y2 < y)&&(tmp1->x-tmp2->y1 > y))
                  return 1;
              } break;
              
              case asLEFT:
              {
                if((tmp1->x+tmp2->y2 < x)&&(tmp1->x+tmp2->y1 > x)&&
                   (tmp1->y-tmp2->y2 < y)&&(tmp1->x-tmp2->y1 > y))
                  return 1;
              } break;
            } 
*/            



          
          } /* ENDE RECHTECK */
                
        tmp2=tmp2->next;
      }
      return 0;
    }
  }
  return 0;     /* never reached */
}




/******************************************************************************
 *** function   : AS_LayoutWin_GetNextGridPoint()
 *** description: Setzt die Mausposition auf den nchsten Gitterpunkt 
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_LayoutWin_GetNextGridPoint(int x, int y, int *gridx, int *gridy)
{
  int a,b,tmpx,tmpy;

  if(LayoutData.StayOnGrid)
  {
    tmpx=(x+LayoutData.GridSize/2)/(a=LayoutData.GridSize);
    tmpy=(y+LayoutData.GridSize/2)/(b=LayoutData.GridSize);
    *gridx=tmpx*a;
    *gridy=tmpy*b;
  }
  else
  {
    *gridx = x;
    *gridy = y;
  }
  return 0;
}


/******************************************************************************
 *** function   : AS_LayoutWin_MotionEvent()
 *** description: Diese Funktion wird bei einem MotionNotifyEvent des 
 ***              Layout-Windows aufgerufen.
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int  AS_LayoutWin_MotionEvent(FL_OBJECT *ob, Window win, int w, int h,
                              XEvent *ev, void *d)
{
  int x,y,xg,yg;
  struct sElement *tmp1;
  
  AS_LayoutWin_GetNextGridPoint(ev->xbutton.x, ev->xbutton.y, &x, &y);

  switch(LayoutData.BasicsMode)
  {


    case JUNCTIONMODE:
    {
      LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
      LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
      AS_LayoutWin_Repaint();
      AS_Layout_DrawElement(LayoutData.ActElement,Colors[SELECTCOLOR],AS_LayoutWin);
    } break;
    


    case LINEMODE:
    case BUSMODE:
    {
      if(LayoutData.FirstPoint==2)
      {
        AS_LayoutWin_Repaint();
        LayoutData.ActElement->Elements->x2 =
          x+LayoutData.CanvasOffsetX-LayoutData.ActElement->x;
        LayoutData.ActElement->Elements->y2 =
          y+LayoutData.CanvasOffsetY-LayoutData.ActElement->y;
    
/* 
       if(LayoutData.BasicsMode==BUSMODE)
          fl_linewidth(3);
*/

        fl_line(LayoutData.ActElement->x-LayoutData.CanvasOffsetX,
                LayoutData.ActElement->y-LayoutData.CanvasOffsetY,
                LayoutData.ActElement->x+LayoutData.ActElement->Elements->x2-LayoutData.CanvasOffsetX,
                LayoutData.ActElement->y+LayoutData.ActElement->Elements->y2-LayoutData.CanvasOffsetY,
                Colors[SELECTCOLOR]);

/*        fl_linewidth(1); */

      }
    } break; /* end case LINEMODE, BUSMODE */
    
  

    case ELEMENTMODE:
    {

/* ToDo1 */
      AS_LayoutWin_Repaint();    
      LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
      LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
      AS_Layout_DrawElement(LayoutData.ActElement,Colors[SELECTCOLOR],AS_LayoutWin);
    } break;  /* end case ELEMENTMODE */
    
    case MOVEMODE:
    {
      if((LayoutData.FirstPoint==1)&&(SelectList!=NULL))
      {
        tmp1=SelectList;
        AS_LayoutWin_GetNextGridPoint(LayoutData.CanvasOffsetX-\
                                      LayoutData.AreaX-(LayoutData.AreaWidth/2),
                                      LayoutData.CanvasOffsetY-\
                                      LayoutData.AreaY-(LayoutData.AreaHeight/2),
                                      &xg,&yg);
        while(tmp1!=NULL)
        {
          tmp1->crossref->x = tmp1->x+x+xg;
          tmp1->crossref->y = tmp1->y+y+yg;
          tmp1=tmp1->next;
        }
        AS_LayoutWin_Repaint();
      }
      else
      {
        LayoutData.LastFound=NULL;
        LayoutData.BasicsMode=NOMODE;
        UnlightButtonsExceptThis(NULL);
      }
    }
    
    
    case AREAMODE:
    {
      if(LayoutData.FirstPoint==2)
      {
        AS_LayoutWin_Repaint();
        fl_rect(LayoutData.AreaX-LayoutData.CanvasOffsetX,
                LayoutData.AreaY-LayoutData.CanvasOffsetY,
                x-LayoutData.AreaX+LayoutData.CanvasOffsetX,
                y-LayoutData.AreaY+LayoutData.CanvasOffsetY,
                Colors[SELECTCOLOR]);
      }
    } break; /* end case AREAMODE */


    case TEXTMODE:
    {
      if(LayoutData.ActElement!=NULL)
      {
        AS_LayoutWin_Repaint();
        LayoutData.ActElement->x = x+LayoutData.CanvasOffsetX;
        LayoutData.ActElement->y = y+LayoutData.CanvasOffsetY;
        AS_Layout_DrawElement(LayoutData.ActElement,Colors[SELECTCOLOR],AS_LayoutWin);
      }
    }break; /* end case TEXTMODE */


    case EDITORMODEVALUEPOS:
    {
      if(SelectList!=NULL)
      {
        SelectList->crossref->ValuePosX=x+LayoutData.CanvasOffsetX-SelectList->crossref->x;
        SelectList->crossref->ValuePosY=y+LayoutData.CanvasOffsetY-SelectList->crossref->y;
        AS_LayoutWin_Repaint();
      }
    } break; /* end EDITORMODEVALUEPOS */


    case EDITORMODEREFNAMEPOS:
    {
      if(SelectList!=NULL)
      {
        SelectList->crossref->NamePosX=x+LayoutData.CanvasOffsetX-SelectList->crossref->x;
        SelectList->crossref->NamePosY=y+LayoutData.CanvasOffsetY-SelectList->crossref->y;
        AS_LayoutWin_Repaint();
      }
    } break; /* end EDITORMODEREFNAMEPOS */

  } /* end switch */
      

  return 0;
}



/******************************************************************************
 *** function   : AS_LayoutWin_ShowGrid()
 *** description: Malt das Gitter
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_LayoutWin_ShowGrid()
{
  int y;
  /* ToDo */
/*  const char DASH[2]={1,9}; */
  char DASH[2];
  
  DASH[0]=1;
  DASH[1]=LayoutData.GridSize-1;

  fl_linestyle(LineOnOffDash);
  fl_dashedlinestyle((const char *)&DASH,2);
  for(y=0;y<LayoutData.CanvasHeight;y+=LayoutData.GridSize)
    fl_line(0,y,LayoutData.CanvasWidth,y,Colors[GRIDCOLOR]);
  fl_linestyle(LineSolid);

  return 0;
}


/******************************************************************************
 *** function   : AS_LayoutWin_Repaint()
 *** description: erneuert das Fenster
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_LayoutWin_Repaint()
{
  struct sElement *tmp1;


  fl_winset(AS_LayoutWin);
  fl_rectf(0,0,LayoutData.CanvasWidth,LayoutData.CanvasHeight,Colors[BGCOLOR]); 

  if(LayoutData.GridOn)
    AS_LayoutWin_ShowGrid();


  tmp1=ElementList;

  /* draw the normal elementlist */
  while(tmp1!=NULL)
  {
    if(AS_Layout_DrawElement(tmp1,(AS_Element_ElementInSelectList(tmp1)==0)?0:Colors[SELECTCOLOR],AS_LayoutWin) !=0)
      break;
    tmp1=tmp1->next;
  }
  
  /* draw a border around the page */
  /* this needs a better handling! */
  /* future release:
     the user may specify a border, which sets the print range */

/*
  fl_rect(-LayoutData.CanvasOffsetX,
         -LayoutData.CanvasOffsetY,
         LayoutData.PageWidth+LayoutData.CanvasWidth,
         LayoutData.PageHeight+LayoutData.CanvasHeight,
         Colors[BORDERCOLOR]);
*/         
         
  

  return 0;
}


/******************************************************************************
 *** function   : AS_LayoutWin_DrawFreeText()
 *** description: Zeichnet ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_LayoutWin_DrawFreeText(int x, int y, int Color, char *Zeile, int Style, int Size)
{
  fl_drw_text(FL_ALIGN_CENTER,x,y,0,0,Color,TextStyle[Style],TextSize[Size],Zeile);
  return 0;
}





/******************************************************************************
 *** function   : AS_LayoutWin_DrawElement()
 *** description: Zeichnet ein Element
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_Layout_DrawElement(struct sElement *dieses, int OtherColor,Window win)
{
  struct sContent *tmp1;
  long Color;
  int CanOffX,CanOffY;

  if(dieses==NULL)
    return -1;

    
  if(win==AS_LayoutWin)
  {
    CanOffX=LayoutData.CanvasOffsetX;
    CanOffY=LayoutData.CanvasOffsetY;
  }
  else
  {
    CanOffX=0;
    CanOffY=0;
  }



  if( (dieses->ElementType == etLINE)||
      (dieses->ElementType == etELEMENT)||     
      (dieses->ElementType == etBUS) )
  {
  
    if(dieses->Elements == NULL)
    {
       fl_show_messages("internal error, you better quit the application");
       return -1;
    }

    tmp1=dieses->Elements;
    

    fl_winset(win);

    
    
    if(OtherColor!=0)
      Color=OtherColor;
    else
      if(dieses->ElementType==etLINE) Color=Colors[WIRECOLOR];
      else
        if(dieses->ElementType==etELEMENT) Color=Colors[ELEMENTCOLOR];
        else
          Color=Colors[BUSCOLOR];


/* FOR FASTER, BUT INCOORECT DRAWING */


/*
    if((dieses->x > CanOffX)&&
       (dieses->x < CanOffX+LayoutData.CanvasWidth)&&
       (dieses->y > CanOffY)&&
       (dieses->y < CanOffY+LayoutData.CanvasHeight))       
*/       
       
       
    while(tmp1 != NULL)
    {

      if(tmp1->Type == asLINE)
      {

        if((dieses->ElementType==etBUS)&&(LayoutData.ShowBusWidth))
          fl_linewidth(LayoutData.BusWidth);


        fl_line(dieses->x+tmp1->x1-CanOffX,
                dieses->y+tmp1->y1-CanOffY,
                dieses->x+tmp1->x2-CanOffX,
                dieses->y+tmp1->y2-CanOffY,
                Color);

        if((dieses->ElementType==etBUS)&&(LayoutData.ShowBusWidth))
          fl_linewidth(1);  

      }
      else
        if(tmp1->Type == asCIRCLE)
        {
          if(tmp1->Modifier == asNORMAL)
            fl_ovall(dieses->x+tmp1->x1-CanOffX,
                     dieses->y+tmp1->y1-CanOffY,
                     tmp1->x2,
                     tmp1->y2,
                     Color);
          else
            fl_ovalf(dieses->x+tmp1->x1-CanOffX,
                     dieses->y+tmp1->y1-CanOffY,
                     tmp1->x2,
                     tmp1->y2,
                     Color);
        }
        else
          if(tmp1->Type == asRECT)
          {
            if(tmp1->Modifier == asNORMAL)
              fl_rect(dieses->x+tmp1->x1-CanOffX,
                      dieses->y+tmp1->y1-CanOffY,
                      tmp1->x2,
                      tmp1->y2,
                      Color);
            else
              fl_rectf(dieses->x+tmp1->x1-CanOffX,
                       dieses->y+tmp1->y1-CanOffY,
                       tmp1->x2,
                       tmp1->y2,
                       Color);
          }
      tmp1=tmp1->next;
    }
    

    if( (LayoutData.ShowRefNames)&&(dieses->ElementType == etELEMENT))
      AS_LayoutWin_DrawFreeText(dieses->x + dieses->NamePosX-CanOffX,\
                                dieses->y + dieses->NamePosY-CanOffY,\
                                Colors[NAMECOLOR],dieses->RefDisplay,\
                                LayoutData.ElemTextStyle,LayoutData.ElemTextSize);
    if( (LayoutData.ShowValues)&&(dieses->ElementType == etELEMENT))
      AS_LayoutWin_DrawFreeText(dieses->x + dieses->ValuePosX-CanOffX,\
                                dieses->y + dieses->ValuePosY-CanOffY,\
                                Colors[VALUECOLOR],dieses->Value,\
                                LayoutData.ElemTextStyle,LayoutData.ElemTextSize);
                                
    
    
  } /* end if etLINE et ELEMENT */
  else
    if(dieses->ElementType == etJUNCTION)
    {
      fl_rectf(dieses->x-2-CanOffX,
               dieses->y-2-CanOffY,
               5,
               5,
               (OtherColor==0) ? Colors[JUNCTIONCOLOR]:OtherColor);
    } /* end JUNCTION */
    else
      if( (dieses->ElementType == etTEXT)&&(LayoutData.ShowText))
      {
        AS_LayoutWin_DrawFreeText(dieses->x-CanOffX,\
                                  dieses->y-CanOffY,\
                                  (OtherColor==0) ? Colors[TEXTCOLOR]:OtherColor,\
                                  dieses->Name,\
                                  LayoutData.FreeTextStyle,dieses->RefNum);
                                  
      } /* end TEXT */
      

  if( (LayoutData.ShowOrigins)&&(dieses->ElementType != etJUNCTION))
  {
    fl_line(dieses->x-2-CanOffX,
            dieses->y-CanOffY,
            dieses->x+2-CanOffX,
            dieses->y-CanOffY,
            Colors[ORIGINCOLOR]);
    fl_line(dieses->x-CanOffX,
            dieses->y-2-CanOffY,
            dieses->x-CanOffX,
            dieses->y+2-CanOffY,
            Colors[ORIGINCOLOR]);
  }
  
  
  return 0;
}

 
