#ifndef AS_PART
#define AS_PART
#endif



#include <forms.h>
#include "global.h"
#include "part.h"
#include "layout.h"





/******************************************************************************
 *** function   : AS_PartWin_ExposeEvent()
 *** description: Diese FUnktion wird bei einem ExposeEvent des Part-Windows
 ***              aufgerufen.
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int  AS_PartWin_ExposeEvent(FL_OBJECT *ob, Window win, int w, int h,
                            XEvent *ev, void *d)
{
  fl_winset(AS_PartWin);
  LayoutData.PartWinWidth=w;
  LayoutData.PartWinHeight=h;
  AS_PartWin_Repaint();
  return 0;
}




/******************************************************************************
 *** function   : AS_PartWin_MotionEvent()
 *** description: Diese FUnktion wird bei einem ExposeEvent des Part-Windows
 ***              aufgerufen.
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int  AS_PartWin_MotionEvent(FL_OBJECT *ob, Window win, int w, int h,
                            XEvent *ev, void *d)
{
  int x,y,xg,yg,dummy;
  int fx,fy;


  fx=LayoutData.PageWidth/LayoutData.PartWinWidth;
  fy=LayoutData.PageHeight/LayoutData.PartWinHeight;
  x=((ev->xbutton.x)-(LayoutData.CanvasWidth/(2*fx)))*fx;
  y=((ev->xbutton.y)-(LayoutData.CanvasHeight/(2*fy)))*fy;
  
  if(x<0) x=0;
  if(y<0) y=0;
  
  AS_LayoutWin_GetNextGridPoint(x,y,&xg,&yg);

  if( (LayoutData.CanvasOffsetX=xg)<0)
    LayoutData.CanvasOffsetX=0;
  if( (LayoutData.CanvasOffsetX=xg)>LayoutData.PageWidth-LayoutData.CanvasWidth)
    AS_LayoutWin_GetNextGridPoint(LayoutData.PageWidth-LayoutData.CanvasWidth,dummy,\
                                  &LayoutData.CanvasOffsetX,&dummy);
    
  if( (LayoutData.CanvasOffsetY=yg)<0)
    LayoutData.CanvasOffsetY=0;
  if( (LayoutData.CanvasOffsetY=yg)>LayoutData.PageHeight-LayoutData.CanvasHeight)
    AS_LayoutWin_GetNextGridPoint(dummy,LayoutData.PageHeight-LayoutData.CanvasHeight,\
                                  &dummy, &LayoutData.CanvasOffsetY);

  AS_PartWin_Repaint();
  AS_LayoutWin_Repaint();
  
  return 0;
}

  


/******************************************************************************
 *** function   : AS_PartWin_Repaint()
 *** description: Diese FUnktion wird bei einem ExposeEvent des Part-Windows
 ***              aufgerufen.
 *** arguments  : viele ;-)
 *** return     : noch unklar ;-)
 *****************************************************************************/
int AS_PartWin_Repaint()
{
  int fx,fy;

  fx=LayoutData.PageWidth/LayoutData.PartWinWidth;
  fy=LayoutData.PageHeight/LayoutData.PartWinHeight;
  
  fl_winset(AS_PartWin);  /* for external use */
  
  fl_rectf(0,0,LayoutData.PartWinWidth,LayoutData.PartWinHeight,Colors[BGCOLOR]);
  fl_rect(LayoutData.CanvasOffsetX/fx,LayoutData.CanvasOffsetY/fy,\
          LayoutData.CanvasWidth/fx,LayoutData.CanvasHeight/fy,\
          Colors[SELECTCOLOR]);
  return 0;
}
