#include <stdio.h>
#include <forms.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include "test.h"
#include "global.h"
#include "element.h"
#include "layout.h"
#include "tools.h"
#include "postscript.h"
#include "part.h"




FILE *AS_PS_OpenFile(char *Name)
{
  return((FILE *)fopen(Name,"w"));
}



int AS_PS_CloseFile(FILE *Output)
{
  return(fclose(Output));
}

int AS_PS_WriteHeader(FILE *Out)
{
  fprintf(Out,"\%%!PS-Adobe-2.0\n");
  fprintf(Out,"\%%\%%Orientation: %s\n",
    (LayoutData.Orientation==PAGEportrait)?"Portrait":"Landscape");
  fprintf(Out,"\%%\%%Pages: 1\n");
  fprintf(Out,"\%%\%%BeginSetup\n");
  fprintf(Out,"\%%\%%IncludeFeature: *PageSize A3\n");
  fprintf(Out,"\%%\%%EndSetup\n");
  fprintf(Out,"\%%\%%EndComments\n");
  
  fprintf(Out,"/DrawLine {\n");
  fprintf(Out,"  moveto\n");
  fprintf(Out,"  lineto\n");
  fprintf(Out,"  %1.1f setlinewidth\n",(float)PostscriptData.LineWidth/10);
  fprintf(Out,"  stroke\n");
  fprintf(Out,"  newpath\n");
  fprintf(Out,"} bind def\n");

  fprintf(Out,"/DrawBus {\n");
  fprintf(Out,"  moveto\n");
  fprintf(Out,"  lineto\n");
  fprintf(Out,"  %1.1f setlinewidth\n",(float)PostscriptData.BusWidth/10);
  fprintf(Out,"  stroke\n");
  fprintf(Out,"  newpath\n");
  fprintf(Out,"} bind def\n");

  fprintf(Out,"/DrawCircle {\n");
  fprintf(Out,"  0 360 arc\n");
  fprintf(Out,"  %1.1f setlinewidth\n",(float)PostscriptData.LineWidth/10);
  fprintf(Out,"  stroke\n");
  fprintf(Out,"  newpath\n");
  fprintf(Out,"} bind def\n");

  fprintf(Out,"/DrawCircleFull {\n");
  fprintf(Out,"  0 360 arc\n");
  fprintf(Out,"  %1.1f setlinewidth\n",(float)PostscriptData.LineWidth/10);
  fprintf(Out,"  fill\n");
  fprintf(Out,"  newpath\n");
  fprintf(Out,"} bind def\n");
  
  fprintf(Out,"\%%\%%Page: 1 1\n");

  fprintf(Out,"%1.1f %1.1f scale\n",(float)PostscriptData.ScaleX/100,
                                    (float)PostscriptData.ScaleY/100);
  
  if(LayoutData.Orientation==PAGElandscape)
  {
    fprintf(Out,"90 rotate\n");
    fprintf(Out,"0 %d translate\n",-PageSize[LayoutData.PageSize][1]);
  }

  return 0;  
}



int AS_PS_DrawElement(FILE *Out, struct sElement *dieses)
{
  struct sContent *tmp1;
  int w,h;

  if( (dieses->ElementType == etLINE)|| 
      (dieses->ElementType == etELEMENT)||     
      (dieses->ElementType == etBUS) )
  {
  
    if(dieses->Elements == NULL)
    {
       fl_show_messages("internal error, you better quit the application");
       return -1;
    }

    tmp1=dieses->Elements;
       
       
    while(tmp1 != NULL)
    {
      if(tmp1->Type == asLINE)
      {

        fprintf(Out,"%d %d %d %d  ",
                dieses->x+tmp1->x1,
                PageSize[LayoutData.PageSize][1]-(dieses->y+tmp1->y1),
                dieses->x+tmp1->x2,
                PageSize[LayoutData.PageSize][1]-(dieses->y+tmp1->y2));
        if(dieses->ElementType==etBUS)
          fprintf(Out,"DrawBus\n");
        else
          fprintf(Out,"DrawLine\n");
      }
      else
        if(tmp1->Type == asCIRCLE)
        {
          /* ToDo */
          /* translation for middle-based drawing! */
          fprintf(Out,"%d %d %d  ",dieses->x+tmp1->x1+tmp1->x2/2,PageSize[LayoutData.PageSize][1]-dieses->y-tmp1->y1-tmp1->x2/2,tmp1->x2/2);
          if(tmp1->Modifier == asNORMAL)
            fprintf(Out,"DrawCircle\n");
          else
            fprintf(Out,"DrawCircleFull\n");
        }
        else
          if(tmp1->Type == asRECT)
          {
            fprintf(Out,"newpath\n");
            fprintf(Out,"%d %d  moveto\n",dieses->x+tmp1->x1,PageSize[LayoutData.PageSize][1]-(dieses->y+tmp1->y1));
            fprintf(Out,"%d %d  rlineto\n",tmp1->x2,0);
            fprintf(Out,"%d %d  rlineto\n",0,-tmp1->y2);
            fprintf(Out,"%d %d  rlineto\n",-tmp1->x2,0);
            fprintf(Out,"%d %d  rlineto\n",0,tmp1->y2);
            fprintf(Out,"  %1.1f setlinewidth\n",(float)PostscriptData.LineWidth/10);
            if(tmp1->Modifier == asNORMAL)
              fprintf(Out,"stroke\n");
            else
              fprintf(Out,"fill\n");
          }
      tmp1=tmp1->next;
    }
    


    if( (LayoutData.ShowRefNames)&&(dieses->ElementType == etELEMENT))
    {
      fl_get_string_dimension(TextStyle[LayoutData.ElemTextStyle],
                              TextSize[LayoutData.ElemTextSize],
                              dieses->RefDisplay,
                              strlen(dieses->RefDisplay),
                              &w,&h);
      fprintf(Out,"%d %d moveto\n",dieses->x+dieses->NamePosX-(w/2),
              PageSize[LayoutData.PageSize][1]-(dieses->y+dieses->NamePosY+(h/2)));
      fprintf(Out,"/%s findfont\n",PostscriptData.Font);
      fprintf(Out,"%d scalefont\n",PostscriptData.TextSize[LayoutData.ElemTextSize]);
      fprintf(Out,"setfont\n");
      fprintf(Out,"(%s) show\n",dieses->RefDisplay);
      fprintf(Out,"newpath\n");
    }
    if( (LayoutData.ShowValues)&&(dieses->ElementType == etELEMENT))
    {
      fl_get_string_dimension(TextStyle[LayoutData.ElemTextStyle],
                              TextSize[LayoutData.ElemTextSize],
                              dieses->Value,
                              strlen(dieses->Value),
                              &w,&h);
      fprintf(Out,"%d %d moveto\n",dieses->x+dieses->ValuePosX-(w/2),
              PageSize[LayoutData.PageSize][1]-(dieses->y+dieses->ValuePosY+(h/2)));
      fprintf(Out,"/%s findfont\n",PostscriptData.Font);
      fprintf(Out,"%d scalefont\n",PostscriptData.TextSize[LayoutData.ElemTextSize]);
      fprintf(Out,"setfont\n");
      fprintf(Out,"(%s) show\n",dieses->Value);
      fprintf(Out,"newpath\n");
    }
  } /* end if etLINE et ELEMENT */
  else
    if(dieses->ElementType == etJUNCTION)
    {
      fprintf(Out,"newpath\n");
      fprintf(Out,"%d %d  moveto\n",dieses->x-2,PageSize[LayoutData.PageSize][1]-(dieses->y-2));
      fprintf(Out,"%d %d  rlineto\n",4,0);
      fprintf(Out,"%d %d  rlineto\n",0,-4);
      fprintf(Out,"%d %d  rlineto\n",-4,0);
      fprintf(Out,"%d %d  rlineto\n",0,4);
      fprintf(Out,"  0.1 setlinewidth\n");
      fprintf(Out,"fill\n");
    } /* end JUNCTION */
    else
      if( (dieses->ElementType == etTEXT)&&(LayoutData.ShowText))
      {
        fl_get_string_dimension(TextStyle[LayoutData.ElemTextStyle],
                                TextSize[LayoutData.ElemTextSize],
                                dieses->Name,
                                strlen(dieses->Name),
                                &w,&h);
        fprintf(Out,"%d %d moveto\n",dieses->x-(w/2),
                PageSize[LayoutData.PageSize][1]-(dieses->y+(h/2)));
        fprintf(Out,"/%s findfont\n",PostscriptData.Font);
        fprintf(Out,"%d scalefont\n",PostscriptData.TextSize[LayoutData.FreeTextSize]);
        fprintf(Out,"setfont\n");
        fprintf(Out,"(%s) show\n",dieses->Name);
        fprintf(Out,"newpath\n");
      } /* end TEXT */


  return 0;
}



int AS_PS_MakePostscriptFile(char *Name)
{
  FILE *dieses;
  struct sElement *tmp1;
  char fname[50];
  

  if( (dieses=AS_PS_OpenFile(Name))==NULL)
  {
    sprintf((char *)&fname,"can't create file '%s'!",Name);
    fl_show_messages((char *)&fname);
    return -1;
  }

  AS_PS_WriteHeader(dieses);

  tmp1=ElementList;

  while(tmp1!=NULL)
  {
    if(AS_PS_DrawElement(dieses,tmp1)!=0)
      break;
    tmp1=tmp1->next;
  }


  fprintf(dieses,"showpage\n");
  AS_PS_CloseFile(dieses);


  return 0;
}



int AS_PS_InitMenu()
{
  char tmp[20];

  fl_set_choice(fd_ConfPrint->cPSPageSize,PostscriptData.PageSize);
  fl_set_choice(fd_ConfPrint->cPSPageLayout,PostscriptData.PageLayout);
  sprintf((char *)&tmp,"%d",PostscriptData.PageBorder);
  fl_set_input(fd_ConfPrint->iPSPageBorder,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.ScaleX);
  fl_set_input(fd_ConfPrint->iPSScaleX,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.ScaleY);
  fl_set_input(fd_ConfPrint->iPSScaleY,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.FreeWidth);
  fl_set_input(fd_ConfPrint->iPSFreeWidth,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.FreeHeight);
  fl_set_input(fd_ConfPrint->iPSFreeHeight,(char *)&tmp);

  sprintf((char *)&tmp,"%d",PostscriptData.LineWidth);
  fl_set_input(fd_ConfPrint->iPSWireWidth,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.BusWidth);
  fl_set_input(fd_ConfPrint->iPSBusWidth,(char *)&tmp);

  sprintf((char *)&tmp,"%d",PostscriptData.TextSize[1]);
  fl_set_input(fd_ConfPrint->iPSSizeTiny,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.TextSize[2]);
  fl_set_input(fd_ConfPrint->iPSSizeSmall,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.TextSize[3]);
  fl_set_input(fd_ConfPrint->iPSSizeNormal,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.TextSize[4]);
  fl_set_input(fd_ConfPrint->iPSSizeMedium,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.TextSize[5]);
  fl_set_input(fd_ConfPrint->iPSSizeLarge,(char *)&tmp);
  sprintf((char *)&tmp,"%d",PostscriptData.TextSize[6]);
  fl_set_input(fd_ConfPrint->iPSSizeHuge,(char *)&tmp);

  fl_set_input(fd_ConfPrint->iPSStyleNormal,(char *)&PostscriptData.TextStyle[1]);
  fl_set_input(fd_ConfPrint->iPSStyleBold,(char *)&PostscriptData.TextStyle[2]);
  fl_set_input(fd_ConfPrint->iPSStyleItalic,(char *)&PostscriptData.TextStyle[3]);
  fl_set_input(fd_ConfPrint->iPSStyleFixed,(char *)&PostscriptData.TextStyle[4]);
  
  fl_set_input(fd_ConfPrint->iPSFont,(char *)&PostscriptData.Font);

  fl_show_form(fd_ConfPrint->ConfPrint,FL_PLACE_CENTER,FL_FULLBORDER,"Print-Config");

  return 0;
}



/* callbacks and freeobj handles for form ConfPrint */
void cb_cPSPageSize(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_cPSPageLayout(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSPageBorder(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSScaleX(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSScaleY(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSFreeWidth(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSFreeHeight(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSWireWidth(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSBusWidth(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSSizeTiny(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSSizeSmall(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSSizeNormal(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSSizeMedium(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSSizeLarge(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSSizeHuge(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSStyleNormal(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSStyleBold(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSStyleItalic(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSStyleFixed(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPSFont(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_bPSOK(FL_OBJECT *ob, long data)
{
  PostscriptData.PageSize=fl_get_choice(fd_ConfPrint->cPSPageSize);
  PostscriptData.PageLayout=fl_get_choice(fd_ConfPrint->cPSPageLayout);
  PostscriptData.PageBorder=atoi(fl_get_input(fd_ConfPrint->iPSPageBorder));
  PostscriptData.ScaleX=atoi(fl_get_input(fd_ConfPrint->iPSScaleX));
  PostscriptData.ScaleY=atoi(fl_get_input(fd_ConfPrint->iPSScaleY));
  PostscriptData.FreeWidth=atoi(fl_get_input(fd_ConfPrint->iPSFreeWidth));
  PostscriptData.FreeHeight=atoi(fl_get_input(fd_ConfPrint->iPSFreeHeight));

  PostscriptData.LineWidth=atoi(fl_get_input(fd_ConfPrint->iPSWireWidth));
  PostscriptData.BusWidth=atoi(fl_get_input(fd_ConfPrint->iPSBusWidth));

  PostscriptData.TextSize[1]=atoi(fl_get_input(fd_ConfPrint->iPSSizeTiny));
  PostscriptData.TextSize[2]=atoi(fl_get_input(fd_ConfPrint->iPSSizeSmall));
  PostscriptData.TextSize[3]=atoi(fl_get_input(fd_ConfPrint->iPSSizeNormal));
  PostscriptData.TextSize[4]=atoi(fl_get_input(fd_ConfPrint->iPSSizeMedium));
  PostscriptData.TextSize[5]=atoi(fl_get_input(fd_ConfPrint->iPSSizeLarge));
  PostscriptData.TextSize[6]=atoi(fl_get_input(fd_ConfPrint->iPSSizeHuge));

  strcpy((char *)&PostscriptData.TextStyle[1],fl_get_input(fd_ConfPrint->iPSStyleNormal));
  strcpy((char *)&PostscriptData.TextStyle[2],fl_get_input(fd_ConfPrint->iPSStyleBold));
  strcpy((char *)&PostscriptData.TextStyle[3],fl_get_input(fd_ConfPrint->iPSStyleItalic));
  strcpy((char *)&PostscriptData.TextStyle[4],fl_get_input(fd_ConfPrint->iPSStyleFixed));
  
  strcpy((char *)&PostscriptData.Font,fl_get_input(fd_ConfPrint->iPSFont));

  AS_Tools_CalcSizedPageSize();

  fl_hide_form(fd_ConfPrint->ConfPrint);
  if(AS_LayoutWin!=0)
    AS_LayoutWin_Repaint();
  if(AS_PartWin!=0)
    AS_PartWin_Repaint();

}

void cb_bPSCancel(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_ConfPrint->ConfPrint);
}

void cb_bPSHelp(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}



int AS_Print_InitMenu()
{
  char fname[300],*tmp1;
  int i;

  if(ElementList==NULL)
  {
    fl_show_messages("empty page!");
    return -1;
  }
  
  fl_set_input(fd_Print->iPrintSpool,PostscriptData.SpoolCmd);
  fl_set_input(fd_Print->iPrintPrinter,PostscriptData.Printer);
  fl_set_input(fd_Print->iPrintViewer,PostscriptData.Viewer);

  if(strlen(LayoutData.FileName)!=0)
  {
    strcpy((char *)&fname,LayoutData.FileName);
    tmp1=(char *)&fname;

    for(i=0;i<strlen((char *)&fname);i++)  
      tmp1++;
      
    while((i!=0)&&(*tmp1!='/'))
    {
      if(*tmp1=='.')
      {
        *tmp1=0;
        break;
      }
      tmp1--;
      i--;
    }

    strncat((char *)&fname,".ps",5);
  }
  else
    strcpy((char *)&fname,"");
    

  fl_set_input(fd_Print->iPrintOutput,(char *)&fname);
  
  fl_show_form(fd_Print->Print,FL_PLACE_CENTER,FL_FULLBORDER,"Print");    
  return 0;
}


/* callbacks and freeobj handles for form Print */
void cb_iPrintSpool(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPrintPrinter(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPrintViewer(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_iPrintOutput(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void cb_bPrintPrint(FL_OBJECT *ob, long data)
{
  fl_show_messages("This option is not yet supported!\nPlease, use the FILE Option.");
}

void cb_bPrintPreview(FL_OBJECT *ob, long data)
{
  char *FileName,*PSviewCMD;
  char fname[300];
  char tmp[300];

  long PSviewPID;
  
  FileName=(char *)fl_get_input(fd_Print->iPrintOutput);
  PSviewCMD=(char *)fl_get_input(fd_Print->iPrintViewer);
  if(strlen(FileName)==0)
  {
    fl_show_messages("no output filename given!");
    return;
  }
  


  if(AS_PS_MakePostscriptFile(FileName)!=0)
  {
    sprintf((char *)&fname,"ERROR creating '%s'",FileName);
    fl_show_messages((char *)&fname);
  }
  else
    /* only show the OK-message if no preview should be performed */
    if(strlen(PSviewCMD)==0)
    {
      sprintf((char *)&fname,"output file created:\n'%s'",FileName);
      fl_show_messages((char *)&fname);
    }

  
  if(strlen(PSviewCMD)!=0)
  {
    sprintf((char *)&fname,"/bin/sh -c \"%s %s\"",PSviewCMD,FileName);
    fprintf(stderr,"%s",fname);
    if((PSviewPID=fl_exe_command((char *)&fname,0))>-1)
    {
      fl_end_command(PSviewPID);
    }
    else
    {
      sprintf((char *)&tmp,"ERROR while executing:\n%s",(char *)&fname);
      fl_show_messages((char *)&tmp);
    }
  }
  

/*
  if(fork()==0)
  {
    if(fork()==0)
    {
      sprintf((char *)&fname,"gv %s",FileName);
      execl("/bin/sh","sh","-c",(char *)&fname,0);
    }
  }
  else
    wait(NULL);
*/    

  return;
  
}

void cb_bPrintCancel(FL_OBJECT *ob, long data)
{
  fl_hide_form(fd_Print->Print);  
}




