#include <forms.h>
#include <dirent.h>
#include <stdlib.h>
#include "global.h"
#include "test.h"
#include "part.h"
#include "layout.h"
#include "element.h"
#include "postscript.h"
#include "tools.h"

int AS_Tools_CountSelectListEntries()
{
  struct sElement *tmp1;
  int i=0;
  
  tmp1=SelectList;
  while(tmp1!=NULL)
  {
    i++;
    tmp1=tmp1->next;
  }
  return i;
}



int AS_Tools_CountElementListEntries()
{
  struct sElement *tmp1;
  int i=0;
  
  tmp1=ElementList;
  while(tmp1!=NULL)
  {
    i++;
    tmp1=tmp1->next;
  }
  return i;
}



int AS_Tools_CutLF(char *Zeile,int MaxSize)
{
  int i=0;
  
  if(Zeile==NULL)
    return -1;
    
  while(i<MaxSize)
  {
    if((int)*Zeile==10)
    {
      *Zeile=0;
      return 0;
    }
    if((int)*Zeile==0)
      return 0;
    Zeile++;
    i++;
  }
  
  *(Zeile-1)=0;  /* cut to allowed string size */
  return -1;
}



void UnlightButtonsExceptThis(FL_OBJECT *ob)
{

#define BUTTCOUNT 8

  int i;

  FL_OBJECT const *LightButts[BUTTCOUNT]=
  {
    fd_Layout->bAddElement,
    fd_Layout->bAddLine,
    fd_Layout->bAddBus,
    fd_Layout->bAddJunction,
    fd_Layout->bAddText,
    fd_Layout->bSelectObject,
    fd_Layout->bSelectArea,
    fd_Layout->bAddSpecial
  };
  
  for(i=0;i<BUTTCOUNT;i++)
    fl_set_button((FL_OBJECT *)LightButts[i],(ob==LightButts[i]) ? 1:0);
  
}




void SetMouseButtonText(char *But1, char *But3, char *But2)
{

  fl_set_object_label(fd_Layout->tMouse1,But1);
  fl_set_object_label(fd_Layout->tMouse3,But3);
  fl_set_object_label(fd_Layout->tMouse2,But2);
  fl_redraw_object(fd_Layout->tMouse1);
  fl_redraw_object(fd_Layout->tMouse2);
  fl_redraw_object(fd_Layout->tMouse3);
  fl_redraw_object(fd_Layout->tMouseBack);
  
}



void AS_Tools_EnableCallbacks()
{
  fl_set_object_callback(fd_Layout->bAddElement,cb_bAddElement,0);
  fl_set_object_callback(fd_Layout->bAddLine,cb_bAddLine,0);
  fl_set_object_callback(fd_Layout->bAddBus,cb_bAddBus,0);
  fl_set_object_callback(fd_Layout->bAddJunction,cb_bAddJunction,0);
  fl_set_object_callback(fd_Layout->bAddText,cb_bAddText,0);
  fl_set_object_callback(fd_Layout->bSelectArea,cb_bSelectArea,0);
  fl_set_object_callback(fd_Layout->bSelEdit,cb_bSelEdit,0);
  fl_set_object_callback(fd_Layout->bSelCut,cb_bSelCut,0);
  fl_set_object_callback(fd_Layout->bSelCopy,cb_bSelCopy,0);
  fl_set_object_callback(fd_Layout->bSelPaste,cb_bSelPaste,0);
  fl_set_object_callback(fd_Layout->bSelMove,cb_bSelMove,0);
  fl_set_object_callback(fd_Layout->bUnselect,cb_bUnselect,0);
  fl_set_object_callback(fd_Layout->mAddSpecial,cb_mAddSpecial,0);
  fl_set_object_callback(fd_Layout->bAddSpecial,cb_bAddSpecial,0);
}


void AS_Tools_DisableCallbacks()
{

#define MAXOBJECTS 14

  int i;
  FL_OBJECT const *Objects[MAXOBJECTS]=
  {
    fd_Layout->bAddElement,
    fd_Layout->bAddLine,
    fd_Layout->bAddBus,
    fd_Layout->bAddJunction,
    fd_Layout->bAddText,
    fd_Layout->bSelectArea,
    fd_Layout->bSelCopy,
    fd_Layout->bSelPaste,
    fd_Layout->bSelCut,
    fd_Layout->bSelEdit,
    fd_Layout->bSelMove,
    fd_Layout->bUnselect,
    fd_Layout->mAddSpecial,
    fd_Layout->bAddSpecial
  };

  for(i=0;i<MAXOBJECTS;i++)
    fl_set_object_callback((FL_OBJECT *)Objects[i],cb_DUMMY,0);
}



void AS_Tools_InitVars()
{
  AS_PartWin = 0;
  AS_LayoutWin = 0;
  AS_PreviewWin = 0;
  LayoutData.ElemTextSize = 3;
  LayoutData.ElemTextStyle = 1;
  LayoutData.FreeTextSize = 3;
  LayoutData.FreeTextStyle = 1;
  LayoutData.ShowText = 1;
  LayoutData.MiniDraw = 0;
  LayoutData.ShowBusWidth = 0;
  LayoutData.BusWidth = 3;
  LayoutData.DirtyDraw = 0;
  LayoutData.GridOn = 1;
  LayoutData.StayOnGrid = 1;
  LayoutData.GridSize = 10;
  LayoutData.SnapSize = 10;
  LayoutData.ShowOrigins = 1;
  LayoutData.ShowRefNames = 1;
  LayoutData.ShowValues = 1;
  LayoutData.CanvasOffsetX=0;
  LayoutData.CanvasOffsetY=0;
  LayoutData.PageSize=PAGEa4;

  LayoutData.Orientation=PAGElandscape;
  LayoutData.ActElement = NULL;
  LayoutData.LastFound = NULL;
  LayoutData.BrowserElement = NULL;
  LayoutData.BasicsMode=NOMODE;
  sprintf((char *)&LayoutData.LibDirPath,"%s/.xelcad/elements/",getenv("HOME"));
  strcpy(LayoutData.FileName,"");

  PostscriptData.TextSize[0]=6;          /* not used */
  PostscriptData.TextSize[1]=8;
  PostscriptData.TextSize[2]=10;
  PostscriptData.TextSize[3]=12;
  PostscriptData.TextSize[4]=14;
  PostscriptData.TextSize[5]=18;
  PostscriptData.TextSize[6]=24;
  strcpy(PostscriptData.TextStyle[0],"");     /* not used */
  strcpy(PostscriptData.TextStyle[1],"");
  strcpy(PostscriptData.TextStyle[2],"Bold");
  strcpy(PostscriptData.TextStyle[3],"Italic"); 
  strcpy(PostscriptData.TextStyle[4],"Fixed");
  strcpy(PostscriptData.Font,"Helvetica");
  PostscriptData.ScaleX=100;
  PostscriptData.ScaleY=100;
  PostscriptData.LineWidth=1;
  PostscriptData.BusWidth=30;
  PostscriptData.PageSize=1;
  PostscriptData.PageLayout=1;
  PostscriptData.PageBorder=30;
  PostscriptData.FreeWidth=0;
  PostscriptData.FreeHeight=0;

  strcpy(PostscriptData.SpoolCmd,"lpr");
  strcpy(PostscriptData.Printer,"lp");
  strcpy(PostscriptData.Viewer,"gv");

  AS_Tools_CalcSizedPageSize();

  ElementList = NULL;
  SelectList  = NULL;
  CopyList    = NULL;

}


int AS_Tools_SaveVars()
{
  FILE *Config;
  char fname[300];

  int i;
  
  
  sprintf((char *)&fname,"%s/.xelcad/.xelcadrc",getenv("HOME"));

  if((Config=fopen((char *)&fname,"w"))==NULL)
    return -1;
  
  fprintf(Config,"#\n# XelCAD configuration file\n");
  fprintf(Config,"#\n# automatically created; DO NOT EDIT!\n#"); 
  fprintf(Config,"ElemTextSize=%d\n",LayoutData.ElemTextSize);
  fprintf(Config,"ElemTextStyle=%d\n",LayoutData.ElemTextStyle);
  fprintf(Config,"FreeTextSize=%d\n",LayoutData.FreeTextSize);
  fprintf(Config,"FreeTextStyle=%d\n",LayoutData.FreeTextStyle);
  fprintf(Config,"ShowText=%d\n",LayoutData.ShowText);
  fprintf(Config,"MiniDraw=%d\n",LayoutData.MiniDraw);
  fprintf(Config,"ShowBusWidth=%d\n",LayoutData.ShowBusWidth);
  fprintf(Config,"BusWidth=%d\n",LayoutData.BusWidth);
  fprintf(Config,"DirtyDraw=%d\n",LayoutData.DirtyDraw);
  fprintf(Config,"GridOn=%d\n",LayoutData.GridOn);
  fprintf(Config,"StayOnGrid=%d\n",LayoutData.StayOnGrid);
  fprintf(Config,"ShowOrigins=%d\n",LayoutData.ShowOrigins);
  fprintf(Config,"ShowRefNames=%d\n",LayoutData.ShowRefNames);
  fprintf(Config,"ShowValues=%d\n",LayoutData.ShowValues);
  fprintf(Config,"PageWidth=%d\n",(int)LayoutData.PageWidth=2000);
  fprintf(Config,"PageHeight=%d\n",(int)LayoutData.PageHeight=1500);
  fprintf(Config,"LibPath=%s\n",LayoutData.LibDirPath);
  for(i=0;i<MAXCOLOR;i++)
    fprintf(Config,"Color%d=%d\n",i,Colors[i]);
  
  fclose(Config);

  return 0;
}


void AS_Tools_InitColors()
{
  Colors[BGCOLOR]=FL_BLACK; 
  Colors[GRIDCOLOR]=FL_GREEN;
  Colors[WIRECOLOR]=FL_SLATEBLUE;
  Colors[BUSCOLOR]=FL_BLUE;
  Colors[JUNCTIONCOLOR]=FL_CYAN;
  Colors[TEXTCOLOR]=FL_WHITE;    
  Colors[ORIGINCOLOR]=FL_WHITE;  
  Colors[ELEMENTCOLOR]=FL_SLATEBLUE; 
  Colors[NAMECOLOR]=FL_YELLOW;    
  Colors[VALUECOLOR]=FL_RED;   
  Colors[SELECTCOLOR]=FL_RED;  
  Colors[BORDERCOLOR]=FL_WHITE;
}


void NotImplemented()
{
  fl_show_messages("Sorry, this feature may be working\nin an upcoming release");
}



int AS_Tools_CheckFileExists(char *fname)
{
  DIR *currdir=NULL;
  struct dirent *inhalt=NULL;
  char *tmp1=NULL;
  char All[300];
  char Path[300];
  char Name[300];
  int i,lenght;
  
  if((lenght=strlen(fname))<1)
    return -1;

  sprintf((char *)&All,"%s",fname);


  for(i=lenght;i>=0;i--)
  {
    if(All[i]=='/')
    {
      All[i]=0;
      tmp1=(char *)&All[i+1];
      break;
    }
  }

  if(tmp1==NULL)     /* no path given */
  {
    sprintf((char *)&Path,"./");
    tmp1=(char *)&All;
  }
  else
    sprintf((char *)&Path,"%s",(char *)&All);

  sprintf((char *)&Name,"%s",tmp1);
  
    
  
  if((currdir=opendir((char *)&Path))!=NULL)
  {
  
    while((inhalt=readdir(currdir))!=NULL)
    {
      if(strcmp(inhalt->d_name,(char *)&Name)==0)
      {
        closedir(currdir);
        return 1;      /* file exists */
      }
    } 
    
    closedir(currdir);
  }
  else
    return -1;        /* invalid path */
    
  return 0;           /* valid path but file does not exist */

}


void AS_Tools_CalcSizedPageSize()
{
  if(LayoutData.Orientation==PAGEportrait)
  {
    LayoutData.PageWidth =PageSize[LayoutData.PageSize][0]
      *((float)((float)1/((float)PostscriptData.ScaleX/(float)10000))/100);
    LayoutData.PageHeight=PageSize[LayoutData.PageSize][1]
      *((float)((float)1/((float)PostscriptData.ScaleY/(float)10000))/100);
  }
  else
  {
    LayoutData.PageWidth =PageSize[LayoutData.PageSize][1]
      *((float)((float)1/((float)PostscriptData.ScaleX/(float)10000))/100);
    LayoutData.PageHeight=PageSize[LayoutData.PageSize][0]
      *((float)((float)1/((float)PostscriptData.ScaleY/(float)10000))/100);
  }
  
}





